#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "fpu2kernel4xi.py">
#<abstract4xi abstract = "FPU kernel management"/>
#<refer4xi reference = "kernel4xi.py"/>
#<verify4xi verification = "10" target = "fpu2kernel4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API  
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'FPU2Kernel4Xi',                       # ACK 5.7.1  p157    

            'add2kernel4fpu',                      # ACK               

            'execute2kernel4fpu',                  # ACK 5.8    p169                                             
            'execute2task4fpu',                    # ACK 5.8    p172   
            'execute2nativekernel4fpu',            # ACK 5.8    p174     
            
            'create2kernel4fpu',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram4fpu',         # ACK 5.7.1  p158  
                       
            'delete2kernel4fpu',                   # ACK

            'fetch2kernel4fpu',                    # ACK 
            
            'get2kernelinfo4fpu',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo4fpu',         # ACK 5.7.3  p164  
            'get2kernelarginfo4fpu',               # ACK 5.7.3  p166                                  
            
            'release2kernel4fpu',                  # ACK 5.7.1  p159                                         
            'retain2kernel4fpu',                   # ACK 5.7.1  p159   
 
            'set2kernel4fpu',                      # ACK 
            'set2kernelcallback4fpu',              # ACK 
            'set2kernelarg4fpu',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel4fpu'                     # ACK 

          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi

# -------------------------------------------------------------------------------------------------
# Buffer                           
# -------------------------------------------------------------------------------------------------
from fpu2buffer4xi import get2bufferinfo4fpu

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from fpu2commandqueue4xi import FPU2CommandQueue4Xi
from fpu2commandqueue4xi import create2commandqueue4fpu 
from fpu2commandqueue4xi import flush2commandqueue4fpu
from fpu2commandqueue4xi import finish2commandqueue4fpu
from fpu2commandqueue4xi import get2commandqueueinfo4fpu
from fpu2commandqueue4xi import release2commandqueue4fpu
from fpu2commandqueue4xi import retain2commandqueue4fpu
from fpu2commandqueue4xi import set2commandqueue4fpu
from fpu2commandqueue4xi import trace2commandqueue4fpu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from fpu2context4xi import FPU2Context4Xi 
from fpu2context4xi import create2context4fpu
from fpu2context4xi import get2context4fpu
from fpu2context4xi import release2context4fpu
from fpu2context4xi import retain2context4fpu
from fpu2context4xi import set2context4fpu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from fpu2device4xi import FPU4Xi
from fpu2device4xi import init2fpu4xi 
from fpu2device4xi import set2fpu4xi
from fpu2device4xi import get2fpu4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from fpu2event4xi import FPU2Event4Xi
from fpu2event4xi import create2event4fpu
from fpu2event4xi import get2eventinfo4fpu
from fpu2event4xi import release2event4fpu
from fpu2event4xi import retain2event4fpu
from fpu2event4xi import set2eventcallback4fpu 
from fpu2event4xi import set2event4fpu
from fpu2event4xi import trace2event4fpu
from fpu2event4xi import wait2event4fpu


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Program module                           
# -------------------------------------------------------------------------------------------------
from fpu2program4xi import FPU2Program4Xi
from fpu2program4xi import add2programwithsource4fpu
from fpu2program4xi import add2programwithbinary4fpu
from fpu2program4xi import build2program4fpu
from fpu2program4xi import compile2program4fpu
from fpu2program4xi import create2programwithsource4fpu
from fpu2program4xi import create2programwithbinary4fpu
from fpu2program4xi import delete2programwithsource4fpu
from fpu2program4xi import delete2programwithbinary4fpu
from fpu2program4xi import get2programinfo4fpu
# from fpu2program4xi import get2programbuildinfo4fpu
from fpu2program4xi import link2program4fpu
from fpu2program4xi import release2program4fpu
from fpu2program4xi import retain2program4fpu
from fpu2program4xi import set2programcallback4fpu 
from fpu2program4xi import set2programwithsource4fpu
from fpu2program4xi import set2programwithbinary4fpu
from fpu2program4xi import trace2program4fpu
# from fpu2program4xi import unload2compiler4fpu

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from process4xi import Process4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                         
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global fpu2kernel4xi                                                    # Kernel of FPU
global fpu2build4xi                                                     # Build of FPU
global fpu2compile4xi                                                   # Compile of FPU
global fpu2trace4xi                                                     # TRACE

global fetch2code4fpu                                                   # Fetched code

global import2use4fpu                                                   # Imports of target function for Process4Xi

global kb2fetch4fpu                                                     # Knowledgebase for fetching
global kb2kernel4fpu                                                    # Knowledgebase for kernel   

global folder2lib4fpu                                                   # Folder of FPU library

global profile2fetch                                                       # Profile knowledgebase for fetching
global keys2profile4fpu

global target2function4fpu                                              # Target function for Process4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
temp2fpu = 'fpu'
key2dir = temp2fpu[0]                                                                                               # MORE COMPLICATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4fpu = VersionKB4Xi[key2dir] 

profile2fetch = {}                                                                                                  # PROFILES FOR FETCHING
profile2fetch ['.py']  = 'ACK'                                                                                    
profile2fetch ['.pyc'] = 'ACK'                                                                                    
profile2fetch ['.cpp'] = 'ACK'                                                                                   
profile2fetch ['.exe'] = 'ACK'       
keys2profile4fpu = profile2fetch.keys()

kb2fetch4fpu = {}                                                                                                   # PROGRAMS TO BE FETCHED - ALWAYS DEFINE BOTH SOURCE AND BINARY PAIRS                               
kb2fetch4fpu[1] = folder2lib4fpu + 'fpu2sampler4xi5test.py'                                                         # Python code
kb2fetch4fpu[2] = folder2lib4fpu + '__pycache__//fpu2sampler4xi.cpython-33.pyc'   
kb2fetch4fpu[3] = folder2lib4fpu + 'fpu2dummy4xi5test.cpp'                                                          # C++ code
kb2fetch4fpu[4] = folder2lib4fpu + "bin//fpu2dummy4xi5test.exe"                                                     # C++ binary

# kb2fetch4fpu[1]  = folder2lib4fpu + 'fpu2sampler4xi5test.py'                                                      
# kb2fetch4fpu[2]  = folder2lib4fpu + '__pycache__//fpu2sampler4xi.cpython-33.pyc'                                  
# kb2fetch4fpu[3]  = folder2lib4fpu + 'fpu2image4xi5test.py'
# kb2fetch4fpu[4]  = folder2lib4fpu + '__pycache__//fpu2image4xi.cpython-33.pyc'
# kb2fetch4fpu[5]  = folder2lib4fpu + 'fpu3image4xi5test.py'
# kb2fetch4fpu[6]  = folder2lib4fpu + '__pycache__//fpu3image4xi.cpython-33.pyc'
# kb2fetch4fpu[7]  = folder2lib4fpu + 'fpu2commandqueue4xi5test.py'
# kb2fetch4fpu[8]  = folder2lib4fpu + '__pycache__//fpu2commandqueue4xi.cpython-33.pyc'
# kb2fetch4fpu[9]  = folder2lib4fpu + 'fpu2event4xi5test.py'
# kb2fetch4fpu[10] = folder2lib4fpu + '__pycache__//fpu2event4xi.cpython-33.pyc'
# kb2fetch4fpu[10]  = folder2lib4fpu + 'FPU2kernel4xi5test.py'
# kb2fetch4fpu[11] = folder2lib4fpu + '__pycache__//fpu2program.cpython-33.pyc'

fetch2code4fpu = {}                                                                                                 # reception arena in memory for code

kb2kernel4fpu = {}
kb2kernel4fpu ['.py'] = {}
kb2kernel4fpu ['.py'] ['TAG']            = "<function4xi function ="                                                
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4fpu ['.py'] ['VALUE']          = "fpu2sampler4xi5test" 
kb2kernel4fpu ['.py'] ['ATTRIBUTE']      = 'usage = "' 

kb2kernel4fpu ['.cpp'] = {}
kb2kernel4fpu ['.cpp'] ['TAG']            = "<function4xi function ="                                               
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4fpu ['.cpp'] ['VALUE']          = "fpu2dummy4xi5test" 
kb2kernel4fpu ['.cpp'] ['ATTRIBUTE']      = 'usage = "kernel'                                                       

#"/>

# -------------------------------------------------------------------------------------------------
# Command queue module of FPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2commandqueue4fpu" usage = " importing target function for Process4Xi">
def importcreate2commandqueue4fpu():
   global target2function4fpu
   from fpu2commandqueue4xi import create2commandqueue4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importflush2commandqueue4fpu" usage = " importing target function for Process4Xi">
def importflush2commandqueue4fpu():
   global target2function4fpu
   from fpu2commandqueue4xi import flush2commandqueue4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importfinish2commandqueue4fpu" usage = " importing target function for Process4Xi">
def importfinish2commandqueue4fpu():
   global target2function4fpu
   from fpu2commandqueue4xi import finish2commandqueue4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importget2commandqueueinfo4fpu" usage = " importing target function for Process4Xi">
def importget2commandqueueinfo4fpu():
   global target2function4fpu
   from fpu2commandqueue4xi import get2commandqueueinfo4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importrelease2commandqueue4fpu" usage = " importing target function for Process4Xi">
def importrelease2commandqueue4fpu():
   global target2function4fpu
   from fpu2commandqueue4xi import release2commandqueue4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importretain2commandqueue4fpu" usage = " importing target function for Process4Xi">
def importretain2commandqueue4fpu():
   global target2function4fpu
   from fpu2commandqueue4xi import retain2commandqueue4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importset2commandqueue4fpu" usage = " importing target function for Process4Xi">
def importset2commandqueue4fpu():
   global target2function4fpu
   from fpu2commandqueue4xi import set2commandqueue4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importtrace2commandqueue4fpu" usage = " importing target function for Process4Xi">
def importtrace2commandqueue4fpu():
   global target2function4fpu
   from fpu2commandqueue4xi import trace2commandqueue4fpu as target2function4fpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Context module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2context4fpu" usage = " importing target function for Process4Xi">
def importcreate2context4fpu():
   global target2function4fpu
   from fpu2context4xi import create2context4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importget2context4fpu" usage = " importing target function for Process4Xi">
def importget2context4fpu():
   global target2function4fpu
   from fpu2context4xi import get2context4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importrelease2context4fpu" usage = " importing target function for Process4Xi">
def importrelease2context4fpu():
   global target2function4fpu
   from fpu2context4xi import release2context4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importretain2context4fpu" usage = " importing target function for Process4Xi">
def importretain2context4fpu():
   global target2function4fpu
   from fpu2context4xi import retain2context4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importset2context4fpu" usage = " importing target function for Process4Xi">
def importset2context4fpu():
   global target2function4fpu
   from fpu2context4xi import set2context4fpu as target2function4fpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Device module of FPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importinit2fpu4xi" usage = " importing target function for Process4Xi">
def importinit2fpu4xi():
   global target2function4fpu
   from fpu2device4xi import init2fpu4xi as target2function4fpu 
#</function4xi>
 
#<function4xi function = "importset2fpu4xi" usage = " importing target function for Process4Xi">
def importset2fpu4xi():
   global target2function4fpu
   from fpu2device4xi import set2fpu4xi   as target2function4fpu
#</function4xi>
 
#<function4xi function = "importget2fpu4xi" usage = " importing target function for Process4Xi">
def importget2fpu4xi():
   global target2function4fpu
   from fpu2device4xi import get2fpu4xi   as target2function4fpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Event module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2event4fpu" usage = " importing target function for Process4Xi">
def importcreate2event4fpu():
   global target2function4fpu
   from fpu2event4xi import create2event4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importget2eventinfo4fpu" usage = " importing target function for Process4Xi">
def importget2eventinfo4fpu():
   global target2function4fpu
   from fpu2event4xi import get2eventinfo4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importrelease2event4fpu" usage = " importing target function for Process4Xi">
def importrelease2event4fpu():
   global target2function4fpu
   from fpu2event4xi import release2event4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importretain2event4fpu" usage = " importing target function for Process4Xi">
def importretain2event4fpu():
   global target2function4fpu
   from fpu2event4xi import retain2event4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importset2eventcallback4fpu" usage = " importing target function for Process4Xi">
def importset2eventcallback4fpu():
   global target2function4fpu
   from fpu2event4xi import set2eventcallback4fpu as target2function4fpu 
#</function4xi>
 
#<function4xi function = "importset2event4fpu" usage = " importing target function for Process4Xi">
def importset2event4fpu():
   global target2function4fpu
   from fpu2event4xi import set2event4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importtrace2event4fpu" usage = " importing target function for Process4Xi">
def importtrace2event4fpu():
   global target2function4fpu
   from fpu2event4xi import trace2event4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importwait2event4fpu" usage = " importing target function for Process4Xi">
def importwait2event4fpu():
   global target2function4fpu
   from fpu2event4xi import wait2event4fpu as target2function4fpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# 2D Image module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2image4fpu" usage = " importing target function for Process4Xi">
def importcreate2image4fpu():
   global target2function4fpu
   from fpu2image4xi import create2image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importget2imageinfo4fpu" usage = " importing target function for Process4Xi">
def importget2imageinfo4fpu():
   global target2function4fpu
   from fpu2image4xi import get2imageinfo4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importget2supportedimageformats4fpu" usage = " importing target function for Process4Xi">
def importget2supportedimageformats4fpu():
   global target2function4fpu
   from fpu2image4xi import get2supportedimageformats4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimage4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimage4fpu():
   global target2function4fpu
   from fpu2image4xi import manoeuvre2copyimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimagetobuffer4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimagetobuffer4fpu():
   global target2function4fpu
   from fpu2image4xi import manoeuvre2copyimagetobuffer4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copybuffertoimage4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copybuffertoimage4fpu():
   global target2function4fpu
   from fpu2image4xi import manoeuvre2copybuffertoimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2readimage4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2readimage4fpu():
   global target2function4fpu
   from fpu2image4xi import manoeuvre2readimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2writeimage4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2writeimage4fpu():
   global target2function4fpu
   from fpu2image4xi import manoeuvre2writeimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2mapimage4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2mapimage4fpu():
   global target2function4fpu
   from fpu2image4xi import manoeuvre2mapimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importcopy2image4fpu" usage = " importing target function for Process4Xi">
def importcopy2image4fpu():
   global target2function4fpu
   from fpu2image4xi import copy2image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importcopy2imagetobuffer4fpu" usage = " importing target function for Process4Xi">
def importcopy2imagetobuffer4fpu():
   global target2function4fpu
   from fpu2image4xi import copy2imagetobuffer4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importcopy2buffertoimage4fpu" usage = " importing target function for Process4Xi">
def importcopy2buffertoimage4fpu():
   global target2function4fpu
   from fpu2image4xi import copy2buffertoimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importread2image4fpu" usage = " importing target function for Process4Xi">
def importread2image4fpu():
   global target2function4fpu
   from fpu2image4xi import read2image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmap2image4fpu" usage = " importing target function for Process4Xi">
def importmap2image4fpu():
   global target2function4fpu
   from fpu2image4xi import map2image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importrelease2image4fpu" usage = " importing target function for Process4Xi">
def importrelease2image4fpu():
   global target2function4fpu
   from fpu2image4xi import release2image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importretain2image4fpu" usage = " importing target function for Process4Xi">
def importretain2image4fpu():
   global target2function4fpu
   from fpu2image4xi import retain2image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importset2imagecallback4fpu" usage = " importing target function for Process4Xi">
def importset2imagecallback4fpu():
   global target2function4fpu
   from fpu2image4xi import set2imagecallback4fpu as target2function4fpu 
#</function4xi>
 
#<function4xi function = "importset2image4fpu" usage = " importing target function for Process4Xi">
def importset2image4fpu():
   global target2function4fpu
   from fpu2image4xi import set2image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importtrace2image4fpu" usage = " importing target function for Process4Xi">
def importtrace2image4fpu():
   global target2function4fpu
   from fpu2image4xi import trace2image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importwait2image4fpu" usage = " importing target function for Process4Xi">
def importwait2image4fpu():
   global target2function4fpu
   from fpu2image4xi import wait2image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importwrite2image4fpu" usage = " importing target function for Process4Xi">
def importwrite2image4fpu():
   global target2function4fpu
   from fpu2image4xi import write2image4fpu as target2function4fpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# 3D Image module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate3image4fpu" usage = " importing target function for Process4Xi">
def importcreate3image4fpu():
   global target2function4fpu
   from fpu3image4xi import create3image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importget3imageinfo4fpu" usage = " importing target function for Process4Xi">
def importget3imageinfo4fpu():
   global target2function4fpu
   from fpu3image4xi import get3imageinfo4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importget3supportedimageformats4fpu" usage = " importing target function for Process4Xi">
def importget3supportedimageformats4fpu():
   global target2function4fpu
   from fpu3image4xi import get3supportedimageformats4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimage4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimage4fpu():
   global target2function4fpu
   from fpu3image4xi import manoeuvre3copyimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimagetobuffer4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimagetobuffer4fpu():
   global target2function4fpu
   from fpu3image4xi import manoeuvre3copyimagetobuffer4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copybuffertoimage4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copybuffertoimage4fpu():
   global target2function4fpu
   from fpu3image4xi import manoeuvre3copybuffertoimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3readimage4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3readimage4fpu():
   global target2function4fpu
   from fpu3image4xi import manoeuvre3readimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3writeimage4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3writeimage4fpu():
   global target2function4fpu
   from fpu3image4xi import manoeuvre3writeimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3mapimage4fpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3mapimage4fpu():
   global target2function4fpu
   from fpu3image4xi import manoeuvre3mapimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importcopy3image4fpu" usage = " importing target function for Process4Xi">
def importcopy3image4fpu():
   global target2function4fpu
   from fpu3image4xi import copy3image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importcopy3imagetobuffer4fpu" usage = " importing target function for Process4Xi">
def importcopy3imagetobuffer4fpu():
   global target2function4fpu
   from fpu3image4xi import copy3imagetobuffer4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importcopy3buffertoimage4fpu" usage = " importing target function for Process4Xi">
def importcopy3buffertoimage4fpu():
   global target2function4fpu
   from fpu3image4xi import copy3buffertoimage4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importread3image4fpu" usage = " importing target function for Process4Xi">
def importread3image4fpu():
   global target2function4fpu
   from fpu3image4xi import read3image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importmap3image4fpu" usage = " importing target function for Process4Xi">
def importmap3image4fpu():
   global target2function4fpu
   from fpu3image4xi import map3image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importrelease3image4fpu" usage = " importing target function for Process4Xi">
def importrelease3image4fpu():
   global target2function4fpu
   from fpu3image4xi import release3image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importretain3image4fpu" usage = " importing target function for Process4Xi">
def importretain3image4fpu():
   global target2function4fpu
   from fpu3image4xi import retain3image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importset3imagecallback4fpu" usage = " importing target function for Process4Xi">
def importset3imagecallback4fpu():
   global target2function4fpu
   from fpu3image4xi import set3imagecallback4fpu as target2function4fpu 
#</function4xi>
 
#<function4xi function = "importset3image4fpu" usage = " importing target function for Process4Xi">
def importset3image4fpu():
   global target2function4fpu
   from fpu3image4xi import set3image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importtrace3image4fpu" usage = " importing target function for Process4Xi">
def importtrace3image4fpu():
   global target2function4fpu
   from fpu3image4xi import trace3image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importwait3image4fpu" usage = " importing target function for Process4Xi">
def importwait3image4fpu():
   global target2function4fpu
   from fpu3image4xi import wait3image4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importwrite3image4fpu" usage = " importing target function for Process4Xi">
def importwrite3image4fpu():
   global target2function4fpu
   from fpu3image4xi import write3image4fpu as target2function4fpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Sampler module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2sampler4fpu" usage = " importing target function for Process4Xi">
def importcreate2sampler4fpu():
   global target2function4fpu
   from fpu2sampler4xi import create2sampler4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importget2samplerinfo4fpu" usage = " importing target function for Process4Xi">
def importget2samplerinfo4fpu():
   global target2function4fpu
   from fpu2sampler4xi import get2samplerinfo4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importrelease2sampler4fpu" usage = " importing target function for Process4Xi">
def importrelease2sampler4fpu():
   global target2function4fpu
   from fpu2sampler4xi import release2sampler4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importretain2sampler4fpu" usage = " importing target function for Process4Xi">
def importretain2sampler4fpu():
   global target2function4fpu
   from fpu2sampler4xi import retain2sampler4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importset2samplercallback4fpu" usage = " importing target function for Process4Xi">
def importset2samplercallback4fpu():
   global target2function4fpu
   from fpu2sampler4xi import set2samplercallback4fpu as target2function4fpu 
#</function4xi>
 
#<function4xi function = "importset2sampler4fpu" usage = " importing target function for Process4Xi">
def importset2sampler4fpu():
   global target2function4fpu
   from fpu2sampler4xi import set2sampler4fpu as target2function4fpu
#</function4xi>
 
#<function4xi function = "importtrace2sampler4fpu" usage = " importing target function for Process4Xi">
def importtrace2sampler4fpu():
   global target2function4fpu
   from fpu2sampler4xi import trace2sampler4fpu as target2function4fpu
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
# Program module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2programwithsource4fpu" usage = " importing target function for Process4Xi">
def importcreate2programwithsource4fpu():
   global target2function4fpu
   from fpu2kernel4xi import create2programwithsource4fpu as target2function4fpu
#</function4xi> 

#<function4xi function = "importcreate2programwithbinary4fpu" usage = " importing target function for Process4Xi">
def importcreate2programwithbinary4fpu():
   global target2function4fpu
   from fpu2kernel4xi import create2programwithbinary4fpu as target2function4fpu
#</function4xi> 

#<function4xi function = "importadd2programwithsource4fpu" usage = " importing target function for Process4Xi">
def importadd2programwithsource4fpu():
   global target2function4fpu
   from fpu2kernel4xi import add2programwithsource4fpu as target2function4fpu
#</function4xi> 

#<function4xi function = "importadd2programwithbinary4fpu" usage = " importing target function for Process4Xi">
def importadd2programwithbinary4fpu():
   global target2function4fpu
   from fpu2kernel4xi import add2programwithbinary4fpu as target2function4fpu
#</function4xi>

#<function4xi function = "importbuild2program4fpu" usage = " importing target function for Process4Xi">
def importbuild2program4fpu():
   global target2function4fpu
   from fpu2kernel4xi import build2program4fpu as target2function4fpu
#</function4xi>

#<function4xi function = "importbuild2program4fpu" usage = " importing target function for Process4Xi">
def importbuild2program4fpu():
   global target2function4fpu
   from fpu2kernel4xi import build2program4fpu as target2function4fpu
#</function4xi>

#<function4xi function = "importcompile2program4fpuX" usage = " importing target function for Process4Xi">
def importcompile2program4fpu():
   global target2function4fpu
   from fpu2kernel4xi import compile2program4fpu as target2function4fpu
#</function4xi>

#<function4xi function = "importdelete2programwithsource4fpuX" usage = " importing target function for Process4Xi">
def importdelete2programwithsource4fpu():
   global target2function4fpu
   from fpu2kernel4xi import delete2programwithsource4fpu as target2function4fpu
#</function4xi>    

#<function4xi function = "importdelete2programwithbinary4fpuX" usage = " importing target function for Process4Xi">
def importdelete2programwithbinary4fpu():
   global target2function4fpu
   from fpu2kernel4xi import delete2programwithbinary4fpu as target2function4fpu
#</function4xi>    

#<function4xi function = "importget2programinfo4fpuX" usage = " importing target function for Process4Xi">
def importget2programinfo4fpu():
   global target2function4fpu
   from fpu2kernel4xi import get2programinfo4fpu as target2function4fpu
#</function4xi>    

#<function4xi function = "importlink2program4fpuX" usage = " importing target function for Process4Xi">
def importlink2program4fpu():
   global target2function4fpu
   from fpu2kernel4xi import link2program4fpu as target2function4fpu
#</function4xi>    

#<function4xi function = "importrelease2program4fpuX" usage = " importing target function for Process4Xi">
def importrelease2program4fpu():
   global target2function4fpu
   from fpu2kernel4xi import release2program4fpu as target2function4fpu
#</function4xi>    

#<function4xi function = "importretain2program4fpuX" usage = " importing target function for Process4Xi">
def importretain2program4fpu():
   global target2function4fpu
   from fpu2kernel4xi import retain2program4fpu as target2function4fpu
#</function4xi>    

#<function4xi function = "importset2programcallback4fpuX" usage = " importing target function for Process4Xi">
def importset2programcallback4fpu():
   global target2function4fpu
   from fpu2kernel4xi import set2programcallback4fpu as target2function4fpu
#</function4xi>    

#<function4xi function = "importset2programwithsource4fpuX" usage = " importing target function for Process4Xi">
def importset2programwithsource4fpu():
   global target2function4fpu
   from fpu2kernel4xi import set2programwithsource4fpu as target2function4fpu
#</function4xi>    

#<function4xi function = "importset2programwithbinary4fpuX" usage = " importing target function for Process4Xi">
def importset2programwithbinary4fpu():
   global target2function4fpu
   from fpu2kernel4xi import set2programwithbinary4fpu as target2function4fpu
#</function4xi>    

#<function4xi function = "importtrace2program4fpuX" usage = " importing target function for Process4Xi">
def importtrace2program4fpu():
   global target2function4fpu
   from fpu2kernel4xi import trace2program4fpu as target2function4fpu
#</function4xi>    

# -------------------------------------------------------------------------------------------------
# Test modules of FPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importfpu2commandqueue4xi5test" usage = " importing target function for Process4Xi">
def importfpu2commandqueue4xi5test():
   global target2function4fpu
   from fpu2commandqueue4xi5test import fpu2commandqueue4xi5test as target2function4fpu
#</function4xi> 

#<function4xi function = "importfpu2event4xi5test" usage = " importing target function for Process4Xi">
def importfpu2event4xi5test():
   global target2function4fpu
   from fpu2event4xi5test import fpu2event4xi5test as target2function4fpu
#</function4xi>
 
#<function4xi function = "importfpu2image4xi5test" usage = " importing target function for Process4Xi">
def importfpu2image4xi5test():
   global target2function4fpu
   from fpu2image4xi5test import fpu2image4xi5test as target2function4fpu
#</function4xi>
 
#<function4xi function = "importfpu3image4xi5test" usage = " importing target function for Process4Xi">
def importfpu3image4xi5test():
   global target2function4fpu
   from fpu3image4xi5test import fpu3image4xi5test as target2function4fpu
#</function4xi>
 
#<function4xi function = "importfpu2sampler4xi5test" usage = " importing target function for Process4Xi">
def importfpu2sampler4xi5test():
   global target2function4fpu
   from fpu2sampler4xi5test import fpu2sampler4xi5test as target2function4fpu
#</function4xi>
 
#<function4xi function = "importFPU2kernel4xi5test" usage = " importing target function for Process4Xi">
def importfpu2kernel4xi5test():
   global target2function4fpu
   from fpu2kernel4xi5test import fpu2kernel4xi5test as target2function4fpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Error handler of FPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "handle2error4fpu" usage = " Error handling for importing target function for Process4Xi">
def handle2error4fpu():
   global import2use4fpu
   print ("HANDLE2ERROR4FPU OF FPU2KERNEL4XI.PY: *** FAILED TO IMPORT TARGET FUNCTION ***")
   keys2import4fpu = import2use4fpu.keys()
   for key2import4fpu in keys2import4fpu:
       print(key2import4fpu,import2use4fpu[key2import4fpu]) 
#</function4xi> 


import2use4fpu = {}
# -------------------------------------------------------------------------------------------------
# Command queue module of FPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4fpu["create2commandqueue4fpu"] = importcreate2commandqueue4fpu        
import2use4fpu["flush2commandqueue4fpu"] = importflush2commandqueue4fpu 
import2use4fpu["finish2commandqueue4fpu"] = importfinish2commandqueue4fpu 
import2use4fpu["get2commandqueueinfo4fpu"] = importget2commandqueueinfo4fpu 
import2use4fpu["release2commandqueue4fpu"] = importrelease2commandqueue4fpu 
import2use4fpu["retain2commandqueue4fpu"] = importretain2commandqueue4fpu 
import2use4fpu["set2commandqueue4fpu"] = importset2commandqueue4fpu 
import2use4fpu["trace2commandqueue4fpu"] = importtrace2commandqueue4fpu 

# -------------------------------------------------------------------------------------------------
# Context module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4fpu["create2context4fpu"] = importcreate2context4fpu 
import2use4fpu["get2context4fpu"] = importget2context4fpu 
import2use4fpu["release2context4fpu"] = importrelease2context4fpu 
import2use4fpu["retain2context4fpu"] = importretain2context4fpu 
import2use4fpu["set2context4fpu"] = importset2context4fpu 

# -------------------------------------------------------------------------------------------------
# Device module of FPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4fpu["init2fpu4xi"] = importinit2fpu4xi 
import2use4fpu["set2fpu4xi"] = importset2fpu4xi 
import2use4fpu["get2fpu4xi"] = importget2fpu4xi 

# -------------------------------------------------------------------------------------------------
# Event module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4fpu["create2event4fpu"] = importcreate2event4fpu 
import2use4fpu["get2eventinfo4fpu"] = importget2eventinfo4fpu 
import2use4fpu["release2event4fpu"] = importrelease2event4fpu 
import2use4fpu["retain2event4fpu"] = importretain2event4fpu 
import2use4fpu["set2eventcallback4fpu"] = importset2eventcallback4fpu 
import2use4fpu["set2event4fpu"] = importset2event4fpu 
import2use4fpu["trace2event4fpu"] = importtrace2event4fpu 
import2use4fpu["wait2event4fpu"] = importwait2event4fpu 

# -------------------------------------------------------------------------------------------------
# 2D Image module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4fpu["create2image4fpu"] = importcreate2image4fpu 
import2use4fpu["get2imageinfo4fpu"] = importget2imageinfo4fpu 
import2use4fpu["get2supportedimageformats4fpu"] = importget2supportedimageformats4fpu 
import2use4fpu["manoeuvre2copyimage4fpu"] = importmanoeuvre2copyimage4fpu 
import2use4fpu["manoeuvre2copyimagetobuffer4fpu"] = importmanoeuvre2copyimagetobuffer4fpu 
import2use4fpu["manoeuvre2copybuffertoimage4fpu"] = importmanoeuvre2copybuffertoimage4fpu 
import2use4fpu["manoeuvre2readimage4fpu"] = importmanoeuvre2readimage4fpu 
import2use4fpu["manoeuvre2writeimage4fpu"] = importmanoeuvre2writeimage4fpu 
import2use4fpu["manoeuvre2mapimage4fpu"] = importmanoeuvre2mapimage4fpu 
import2use4fpu["copy2image4fpu"] = importcopy2image4fpu 
import2use4fpu["copy2imagetobuffer4fpu"] = importcopy2imagetobuffer4fpu 
import2use4fpu["copy2buffertoimage4fpu"] = importcopy2buffertoimage4fpu 
import2use4fpu["read2image4fpu"] = importread2image4fpu 
import2use4fpu["map2image4fpu"] = importmap2image4fpu 
import2use4fpu["release2image4fpu"] = importrelease2image4fpu 
import2use4fpu["retain2image4fpu"] = importretain2image4fpu 
import2use4fpu["set2imagecallback4fpu"] = importset2imagecallback4fpu 
import2use4fpu["set2image4fpu"] = importset2image4fpu 
import2use4fpu["trace2image4fpu"] = importtrace2image4fpu 
import2use4fpu["wait2image4fpu"] = importwait2image4fpu 
import2use4fpu["write2image4fpu"] = importwrite2image4fpu 

# -------------------------------------------------------------------------------------------------
# 3D Image module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4fpu["create3image4fpu"] = importcreate3image4fpu 
import2use4fpu["get3imageinfo4fpu"] = importget3imageinfo4fpu 
import2use4fpu["get3supportedimageformats4fpu"] = importget3supportedimageformats4fpu 
import2use4fpu["manoeuvre3copyimage4fpu"] = importmanoeuvre3copyimage4fpu 
import2use4fpu["manoeuvre3copyimagetobuffer4fpu"] = importmanoeuvre3copyimagetobuffer4fpu 
import2use4fpu["manoeuvre3copybuffertoimage4fpu"] = importmanoeuvre3copybuffertoimage4fpu 
import2use4fpu["manoeuvre3readimage4fpu"] = importmanoeuvre3readimage4fpu 
import2use4fpu["manoeuvre3writeimage4fpu"] = importmanoeuvre3writeimage4fpu 
import2use4fpu["manoeuvre3mapimage4fpu"] = importmanoeuvre3mapimage4fpu 
import2use4fpu["copy3image4fpu"] = importcopy3image4fpu 
import2use4fpu["copy3imagetobuffer4fpu"] = importcopy3imagetobuffer4fpu 
import2use4fpu["copy3buffertoimage4fpu"] = importcopy3buffertoimage4fpu 
import2use4fpu["read3image4fpu"] = importread3image4fpu 
import2use4fpu["map3image4fpu"] = importmap3image4fpu 
import2use4fpu["release3image4fpu"] = importrelease3image4fpu 
import2use4fpu["retain3image4fpu"] = importretain3image4fpu 
import2use4fpu["set3imagecallback4fpu"] = importset3imagecallback4fpu 
import2use4fpu["set3image4fpu"] = importset3image4fpu 
import2use4fpu["trace3image4fpu"] = importtrace3image4fpu 
import2use4fpu["wait3image4fpu"] = importwait3image4fpu 
import2use4fpu["write3image4fpu"] = importwrite3image4fpu 

# -------------------------------------------------------------------------------------------------
# Sampler module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4fpu["create2sampler4fpu"] = importcreate2sampler4fpu 
import2use4fpu["get2samplerinfo4fpu"] = importget2samplerinfo4fpu 
import2use4fpu["release2sampler4fpu"] = importrelease2sampler4fpu 
import2use4fpu["retain2sampler4fpu"] = importretain2sampler4fpu 
import2use4fpu["set2samplercallback4fpu"] = importset2samplercallback4fpu 
import2use4fpu["set2sampler4fpu"] = importset2sampler4fpu 
import2use4fpu["trace2sampler4fpu"] = importtrace2sampler4fpu 

# -------------------------------------------------------------------------------------------------
# Program module of FPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4fpu["trace2program4fpu"] = importtrace2program4fpu
import2use4fpu["set2programwithbinary4fpu"] = importset2programwithbinary4fpu
import2use4fpu["set2programwithsource4fpu"] = importset2programwithsource4fpu
import2use4fpu["set2programcallback4fpu"] = importset2programcallback4fpu
import2use4fpu["retain2program4fpu"] = importretain2program4fpu
import2use4fpu["release2program4fpu"] = importrelease2program4fpu
import2use4fpu["link2program4fpu"] = importlink2program4fpu
import2use4fpu["get2programinfo4fpu"] = importget2programinfo4fpu
import2use4fpu["delete2programwithbinary4fpu"] = importdelete2programwithbinary4fpu
import2use4fpu["delete2programwithsource4fpu"] = importdelete2programwithsource4fpu
import2use4fpu["compile2program4fpu"] = importcompile2program4fpu
import2use4fpu["build2program4fpu"] = importbuild2program4fpu
import2use4fpu["build2program4fpu"] = importbuild2program4fpu
import2use4fpu["add2programwithbinary4fpu"] = importadd2programwithbinary4fpu
import2use4fpu["add2programwithsource4fpu"] = importadd2programwithsource4fpu
import2use4fpu["create2programwithbinary4fpu"] = importcreate2programwithbinary4fpu
import2use4fpu["create2programwithsource4fpu"] = importcreate2programwithsource4fpu



# -------------------------------------------------------------------------------------------------
# Test modules of FPU imports for target function                             
# -------------------------------------------------------------------------------------------------
import2use4fpu["fpu2commandqueue4xi5test"] = importfpu2commandqueue4xi5test 
import2use4fpu["fpu2event4xi5test"] = importfpu2event4xi5test 
import2use4fpu["fpu2image4xi5test"] = importfpu2image4xi5test 
import2use4fpu["fpu3image4xi5test"] = importfpu3image4xi5test 
import2use4fpu["fpu2sampler4xi5test"] = importfpu2sampler4xi5test 
import2use4fpu["fpu2kernel4xi5test"] = importfpu2kernel4xi5test 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2kernel4fpu" usage = "
#
#   print('=' *33)          
#   print('(Step 15A/25) OF FPU2KERNEL4XI5TEST - TRYING TO TRACE FPU: ', time4xi())      
#   print('=' *33)      
#   trace2fpu = None
#   try:
#       trace2fpu = trace2kernel4fpu() 
#       print('(Step 15B/25) OF FPU2KERNEL4XI5TEST - TRACE2FPU: ', trace2fpu)  
#       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4fpu-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4fpu', 'METHOD': 'trace2kernel4fpu'} 
#   except:
#       print('(Step 15Z1/25) OF FPU2KERNEL4XI5TEST *** FAILED TO TRACE FPU: ', trace2fpu) 
#      
#">

# -------------------------------------------------------------------------------------------------   
def trace2kernel4fpu(task4trace2fpu=None):  

    '''
    creates callback to fpu2kernel4xi
    '''
    
    global fpu2trace4xi
    global folder2lib4fpu    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2kernel4fpu" 
    method2print = "trace2kernel4fpu"

    message2print = "{(Step 1A/33) started" + "; trace2kernel4fpu-started: " + str(trace2kernel4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                               
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2fpu-to-trace2kernel4fpu: " + str(task4trace2fpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    fpu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2fpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY FPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2fpu = {}                                                                                            
            
        task4trace2fpu['CLASS']   = "trace2kernel4fpu"                                                              # FPUIZE ZPU TRACE!
        task4trace2fpu['METHOD']  = "trace2kernel4fpu" 
        task4trace2fpu['MESSAGE'] = "{(Step 2Z0/33) failed" + "; trace2kernel4fpu-failed " + str(fpu2trace4xi)  + "; time: " + time4xi() + "}"               
  
        
        message2print = "{(Step 2A/33) set" + "; task4trace2fpu-set-by-trace2kernel4fpu to: " + str(task4trace2fpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # PARAMETER GIVEN BY FPUIZED CALLBACK !
    # -----------------------------------------------------------------------------------------          
    message2print = "{(Step 3A/33) try" + "; task4trace2fpu-try-by-trace2kernel4fpu: " + str(task4trace2fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
    # 

    try:
        fpu2trace4xi ['CLASS']  = task4trace2fpu['CLASS']                                                           # FPUIZE FPU TRACE!
        fpu2trace4xi ['METHOD']  = task4trace2fpu['METHOD']
        fpu2trace4xi ['MESSAGE'] = task4trace2fpu['MESSAGE']
        
        message2print = "{(Step 3B/33) set" + "; fpu2trace4xi-set-by-trace2kernel4fpu to: " + str(fpu2trace4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 

        code2ack = code2ack + '3B-'         
    except:
        message2print = "{(Step 3Z1/33) failed" + "; fpu-trace-failed-by-trace2kernel4fpu: " + str(task4trace2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z1-' 
        
    try:
        # =================================
        # SIMULATE FPU TRACE
        # =================================
        class2print   = task4trace2fpu['CLASS']                                                                     # FPUIZE FPU TRACE!
        method2print  = task4trace2fpu['METHOD']
        
        message2print = task4trace2fpu['MESSAGE']
        print4xi(class2print, method2print, message2print)                                                          # FPUIZED TRACE FOR OPENCL CALLBACK!
        # 
        
        
        code2ack = code2ack + '3C-'         
    except:
        class2print = "trace2kernel4fpu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4fpu"   
        message2print = "{(Step 3Z2/33) failed" + "; simulation-of-fpu-trace-failed-by-trace2kernel4fpu: " + str(task4trace2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z2-' 
        
    try:
        # =================================
        # NORMAL TRACE
        # =================================                     
        class2print = "trace2kernel4fpu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4fpu"                
        message2print = "{(Step 3D/33) performed" + "; fpu-trace-performed-by-trace2kernel4fpu: " + str(task4trace2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack = code2ack + '3D-' 
    except:
        message2print = "{(Step 3Z3/33) failed" + "; fpu-trace-failed-by-trace2kernel4fpu: " + str(task4trace2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z3-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; fpu2trace4xi-returning-by-trace2kernel4fpu: " + str(fpu2trace4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return fpu2trace4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2kernel4fpu" usage = "
#
#   response4execute2kernel = execute2kernel4fpu()
#      
#">

# -------------------------------------------------------------------------------------------------   
def execute2kernel4fpu(task4execute2fpu=None):  

    '''
    executes kernel to FPU 
    '''
    global folder2lib4fpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2kernel4fpu" 
    method2print = "execute2kernel4fpu"

    message2print = "{(Step 1A/33) started" + "; execute2kernel4fpu-started: " + str(execute2kernel4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
          
    message2print = "{(Step 1B/33) passed" + "; task4execute2fpu-to-execute2kernel4fpu: " + str(task4execute2fpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                            # 
    # 
    status4execute2fpu = 'CL_SUCCESS'
    
    code2ack  = ' '
    code2nack = ' '    
    
                                                                                                                  #       
    if task4execute2fpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN - BUILD THEM
        # -----------------------------------------------------------------------------------------    
        task4execute2fpu = {}                                                                                            

        message2print = "{(Step 2A/33) set" + "; task4execute2fpu-set-by-execute2kernel4fpu to: " + str(task4execute2fpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------          
    status4execute2fpu = 'CL_SUCCESS'
    message2print = "{(Step 3A/33) set" + "; status4execute2fpu-set-by-execute2kernel4fpu to: " + str(status4execute2fpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; status4execute2fpu-returning-by-execute2kernel4fpu: " + str(status4execute2fpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return status4execute2fpu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelcallback4fpu" usage = "
#
#   print('(Step 14A/700) OF FPU2KERNEL4XI5TEST - TRYING TO SET PROGRAM CALLBACK OF FPU ', time4xi())  
#   try:                               
#       response4setcallback2program = set2kernelcallback4fpu()                                                                                                 
#       print('(Step 14B/700) OF FPU2KERNEL4XI5TEST - SET PROGRAM CALLBACK OF FPU TO: ', response4setcallback2program)   
#       # 
#   except:
#       print('(Step 14Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO SET PROGRAM CALLBACK OF FPU ', time4xi())  
# 
#">

# ------------------------------------------------------------------------------------------------- 
 
def set2kernelcallback4fpu(task4set2kernelcallback=None):

    '''
    registers callback function to fpu2kernel4xi
    '''
    global fpu2kernel4xi
    global folder2lib4fpu  
        
    class2print = "set2kernelcallback4fpu" 
    method2print = "set2kernelcallback4fpu"
    
    message2print = "{(Step 2A/70) started" + "; set2kernelcallback4fpu-started: " + str(set2kernelcallback4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # set2kernelcallback4fpu-started
    
    try:
    
        fpu2kernel4xi ['CALLBACK'] = trace2kernel4fpu
        
        
        message2print = "{(Step 2C/70) returning" + "; callback-of-fpu2kernel4xi-returning-by-set2kernelcallback4fpu: " + str(fpu2kernel4xi ['CALLBACK']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print) 
        # 
        
        return fpu2kernel4xi ['CALLBACK']      
        
    except:
        message2print = "{(Step 2Z1/70) failed" + "; callback2program-failed-by-set2kernelcallback4fpu: " + str(callback2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         

        message2print = "{(Step 2Z2/70) returning" + "; trace2kernel4fpu-returning-by-set2kernelcallback4fpu: " + str(trace2kernel4fpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)      
            
        return trace2kernel4fpu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2task4fpu" usage = "
#
#   try:                               
#       response4execute2task = execute2task4fpu(task4execute2task)
#       print('(Step 99B/700) OF FPU2KERNEL4XI5TEST - BUILT PROGRAM OF FPU DEVICE ', time4xi())
#   except:
#       print('(Step 99Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO EXECUTE PROGRAM OF FPU DEVICE ', time4xi())  
#                 
#">

# -------------------------------------------------------------------------------------------------   
def execute2task4fpu(task4execute2fpu=None):

    '''
    executes  program to FPU 
    '''
    global fpu2execute4xi
    global folder2lib4fpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2task4fpu"
    method2print = "execute2task4fpu" 

    message2print = "{(Step 1A/33) started" + "; execute2task4fpu-started: " + str(execute2task4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # execute2task4fpu-started
    
    
    message2print = "{(Step 1B/33) passed" + "; task4execute2fpu-to-execute2task4fpu: " + str(task4execute2fpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
             
    code2ack  = ' '
    code2nack = ' '

    message2print = "{(Step 1A/70) try" + "; execute-try-by-execute2task4fpu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    try:             
        if task4execute2fpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - EXECUTE TASK TO FPU! 
            # -----------------------------------------------------------------------------------------    
            task4execute2fpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4execute2fpu-initialized-by-execute2task4fpu: " + str(task4execute2fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 
            
            # ---------------------------------------------------------------------------------------------
            # (1) KERNEL REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            program2fpu = {}
            message2print = "{(Step 1A/70) trying" + "; program2fpu-trying-by-create2kernel4fpu: " + str(program2fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                program2fpu = create2kernel4fpu()                                                                     
                
                message2print = "{(Step 1B/70) got" + "; program2fpu-got-by-create2kernel4fpu: " + str(program2fpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                #                 
                code2ack  = code2ack + '1B-'         
            except:
                message2print = "{(Step 1Z/70) failed" + "; program2fpu-failed-by-create2kernel4fpu: " + str(program2fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '1Z-'
                
            task4execute2fpu ['PROGRAM'] = program2fpu
            
            # ---------------------------------------------------------------------------------------------
            # (2) OPTIONS - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            task4execute2task  ['OPTIONS'] = {}
          
            
            # ---------------------------------------------------------------------------------------------
            # (3) CALLBACK - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            function2callback4fpu = trace2kernel4fpu                                                               # CALLBACK FUNCTION FOR FPU
            
            message2print = "{(Step 3A/70) initialized" + "; function2callback4fpu-created-by-execute2task4fpu: " + str(function2callback4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 
            
            code2ack  = code2ack + '3A-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "execute2task4fpu"                                                            # MODULE OF FPUIZED OPENCL MODULE
            args2callback['METHOD']  = "execute2task4fpu"                                                            # FUNCTION OF FPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 3Z1/33) failed" + "; execute2task4fpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR FPUIZED OPENCL TO RETURN    

            message2print = "{(Step 3B/70) initialized" + "; args2callback-created-by-execute2task4fpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 

            code2ack  = code2ack + '3B-'
            
           
            task4execute2fpu['DATA2CALLBACK'] = args2callback                                                       # USER DATA PASSED TO FPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4execute2fpu['FUNCTION2CALLBACK'] = function2callback4fpu                                           # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '3C-'

            
            # ---------------------------------------------------------------------------------------------
            # (4) USERDATA - REQUIRED                         
            # ---------------------------------------------------------------------------------------------
            task4execute2fpu['USERDATA'] = None 
            
            message2print = "{(Step 4A/70) initialized" + "; task4execute2fpu-created-by-execute2task4fpu: " + str(task4execute2fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #
        else:
            pass                                                                  
    except:
        message2print = "{(Step 1Z1/70) yielded" + "; task4execute2fpu-yielded-by-execute2task4fpu: " + str(task4execute2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-'  
                                                                                                 
    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4execute2fpu.keys()        
    message2print = "{(Step 9/70) using" + "; keys2task-using-by-execute2task4fpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 
  
    # ---------------------------------------------------------------------------------------------
    # (Step 10A/70) - CREATE EXECUTE FOR FPU ! 
    # ---------------------------------------------------------------------------------------------    
    fpu2execute4xi = {}                                                                                                                                                                               
    message2print = "{(Step 10A/70) initialized" + "; fpu2execute4xi-initialized-by-execute2task4fpu to: " + str(fpu2execute4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    message2print = "{(Step 11A0/70) try" + "; program-try-by-execute2task4fpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 11A/70) - PROGRAM - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        fpu2execute4xi['PROGRAM'] = task4execute2fpu['PROGRAM']
        
        message2print = "{(Step 11A1/70) initialized" + "; program-created-by-execute2task4fpu: " + str(fpu2execute4xi['PROGRAM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '11A1-'
    except: 
        message2print = "{(Step 11Z1/70) yielded" + "; program-fpu2execute4xi-yielded-by-execute2task4fpu: " + str(fpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '11Z1-' 
           
    message2print = "{(Step 12A0/70) try" + "; options-try-by-execute2task4fpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 12A/70) - OPTIONS - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        fpu2execute4xi['OPTIONS'] = task4execute2fpu['OPTIONS']
        
        message2print = "{(Step 12A1/70) initialized" + "; options-created-by-execute2task4fpu: " + str(fpu2execute4xi['OPTIONS'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '12A1-'
    except: 
        message2print = "{(Step 12Z1/70) yielded" + "; options-fpu2execute4xi-yielded-by-execute2task4fpu: " + str(fpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '12Z1-' 
        
    message2print = "{(Step 13A0/70) try" + "; callback-try-by-execute2task4fpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 13A/70) - CALLBACK - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        fpu2execute4xi['CALLBACK'] = task4execute2fpu['CALLBACK']
        
        message2print = "{(Step 13A1/70) initialized" + "; callback-created-by-execute2task4fpu: " + str(fpu2execute4xi['CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '13A1-'
    except: 
        message2print = "{(Step 13Z1/70) yielded" + "; callback-fpu2execute4xi-yielded-by-execute2task4fpu: " + str(fpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '13Z1-' 
        
    message2print = "{(Step 14A0/70) try" + "; userdata-try-by-execute2task4fpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 14A/70) - USERDATA - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        fpu2execute4xi['USERDATA'] = task4execute2fpu['USERDATA']
        
        message2print = "{(Step 14A1/70) initialized" + "; userdata-created-by-execute2task4fpu: " + str(fpu2execute4xi['USERDATA'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '14A1-'
    except: 
        message2print = "{(Step 14Z1/70) yielded" + "; userdata-fpu2execute4xi-yielded-by-execute2task4fpu: " + str(fpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '14Z1-'
                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    fpu2execute4xi ['ACK2RETURN']  = code2ack
    fpu2execute4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; fpu2execute4xi-returning-by-execute2task4fpu: " + str(fpu2execute4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    
    return fpu2execute4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernel4fpu" usage = "
#     
#   print('(Step 2A1/700) OF FPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR FPU ', time4xi())       
#   try:
#       response4create2kernel = create2kernel4fpu()
#   except:
#       print('(Step 2Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR FPU *** ', time4xi())
#          
#">

# -------------------------------------------------------------------------------------------------   
def create2kernel4fpu(task4kernel2fpu=None):

    '''
    creates kernel for FPU
    '''
    global fpu2kernel4xi                                                                                            # Kernel of FPU    
    global folder2lib4fpu  
    global kb2kernel4fpu                                                                                            # Knowledgebase for kernel      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernel4fpu" 
    method2print = "create2kernel4fpu"

    message2print = "{(Step 1A/70) started" + "; create2kernel4fpu-started: " + str(create2kernel4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2kernel4fpu at 0x0000000003AAD8C8> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2fpu-to-create2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    #1: None
    #2: 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    fpu2kernel4xi = {}                                                                                              # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernel2fpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO FPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4kernel2fpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4kernel2fpu-created-by-create2kernel4fpu: " + str(task4kernel2fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - EXTRA                 
            # ---------------------------------------------------------------------------------------------
                        
            function2callback4fpu = trace2kernel4fpu                                                                # CALLBACK FUNCTION FOR FPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4fpu-created-by-create2kernel4fpu: " + str(function2callback4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4fpu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4fpu"                                                          # MODULE OF FPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4fpu"                                                          # FUNCTION OF FPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4fpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR FPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4fpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4fpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4fpu',
            #  'METHOD': 'create2kernel4fpu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2fpu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO FPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2fpu['FUNCTION2CALLBACK'] = function2callback4fpu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2fpu-created-by-create2kernel4fpu: " + str(task4kernel2fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4fpu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4fpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4fpu',
            #  'METHOD': 'create2kernel4fpu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}


            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-created-by-create2kernel4fpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            try:
                platform2xi = get2platformids4xi()                                                                  # PLATFORM IS COMMON TO ALL DEVICES I.E TO DEVICE XI
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2kernel4fpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 03:33:11 12/06/11 Pacific Standard Time}
                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2kernel4fpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4kernel2fpu['PLATFORM'] = platform2xi                                                               # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - EXTRA                   
            # ---------------------------------------------------------------------------------------------    
            context2fpu = {}
            message2print = "{(Step 3A/70) trying" + "; context2fpu-trying-by-create2kernel4fpu: " + str(context2fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2fpu = get2context4fpu()                                                                     # NO PARAMETERS - THE SYSTEM CREATES CONTEXT IF REQUIRED  
                
                message2print = "{(Step 3B/70) got" + "; context2fpu-got-by-create2kernel4fpu: " + str(context2fpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2fpu-failed-by-create2kernel4fpu: " + str(context2fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
                
            task4kernel2fpu ['CONTEXT'] = context2fpu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------    
            device2fpu = {}
            
            message2print = "{(Step 4A/70) trying" + "; device2fpu-trying-by-create2kernel4fpu: " + str(device2fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2fpu = get2fpu4xi()                                                                           # THE SYSTEM CREATES DEVICE INFO, IF NECESSARY    
                
                message2print = "{(Step 4B/70) got" + "; device2fpu-got-by-create2kernel4fpu: " + str(device2fpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2fpu-failed-by-create2kernel4fpu: " + str(device2fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4kernel2fpu ['DEVICE'] = device2fpu
            
                   
            # ---------------------------------------------------------------------------------------------
            # (5) ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4kernel2fpu ['CODE2ERROR'] = 0             
            code2ack  = code2ack + '5B-'              

            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            queue2fpu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2fpu-trying-by-create2kernel4fpu: " + str(queue2fpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2fpu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2fpu-got-by-create2kernel4fpu: " + str(queue2fpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2fpu-failed-by-create2kernel4fpu: " + str(queue2fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2fpu ['QUEUE'] = queue2fpu

            
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - EXTRA                              
            # ---------------------------------------------------------------------------------------------         
            pipe2fpu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2fpu-trying-by-create2kernel4fpu: " + str(pipe2fpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2fpu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2fpu-got-by-create2kernel4fpu: " + str(pipe2fpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2fpu-failed-by-create2kernel4fpu: " + str(pipe2fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2fpu ['PIPE'] = pipe2fpu 
            
            # ---------------------------------------------------------------------------------------------
            # (8) COMMAND QUEUE INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            commandqueueinfo2fpu = {}
           
            message2print = "{(Step 8A/70) trying" + "; commandqueueinfo2fpu-trying-by-create2kernel4fpu: " + str(commandqueueinfo2fpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                        
            try:
                commandqueueinfo2fpu = get2commandqueueinfo4fpu()                                                   # SYSTEM CREATES COMMAND QUEUE, IF NECESSARY   
                message2print = "{(Step 8B/70) got" + "; commandqueueinfo2fpu-got-by-create2kernel4fpu: " + str(commandqueueinfo2fpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '8B-'  
            except:
                message2print = "{(Step 8Z/70) failed" + "; commandqueueinfo2fpu-failed-by-create2kernel4fpu: " + str(commandqueueinfo2fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '8Z-'
        
            task4kernel2fpu ['COMMANDQUEUE'] = commandqueueinfo2fpu
            
            
            
            # ---------------------------------------------------------------------------------------------
            # (9) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            bufferinfo2fpu = {}
           
            message2print = "{(Step 9A/70) trying" + "; bufferinfo2fpu-trying-by-create2kernel4fpu: " + str(bufferinfo2fpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                bufferinfo2fpu = get2bufferinfo4fpu()                                                               # SYSTEM CREATES BUFFER FOR FPU, IF NECESSARY
                message2print = "{(Step 9B/70) got" + "; bufferinfo2fpu-got-by-create2kernel4fpu: " + str(bufferinfo2fpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '9B-' 
            except:
                message2print = "{(Step 9Z/70) failed" + "; bufferinfo2fpu-failed-by-create2kernel4fpu: " + str(bufferinfo2fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '9Z-'
        
            task4kernel2fpu ['BUFFER'] = bufferinfo2fpu 
            
            # ---------------------------------------------------------------------------------------------
            # (10) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            eventinfo2fpu = {}
           
            message2print = "{(Step 10A/70) trying" + "; eventinfo2fpu-trying-by-create2kernel4fpu: " + str(eventinfo2fpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                eventinfo2fpu = get2eventinfo4fpu()                                                                 # SYSTEM CREATES EVENT IF NECESSAY   
                message2print = "{(Step 10B/70) got" + "; eventinfo2fpu-got-by-create2kernel4fpu: " + str(eventinfo2fpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'DATA2CALLBACK': ... 
                
                code2ack  = code2ack + '10B-' 
            except:
                message2print = "{(Step 10Z/70) failed" + "; eventinfo2fpu-failed-by-create2kernel4fpu: " + str(eventinfo2fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '10Z-'
        
            task4kernel2fpu ['EVENT'] = eventinfo2fpu             

            
            task4kernel2fpu ['CODE4PY']       = {}                                                                  
            task4kernel2fpu ['CODE4CPP']      = {}                                                                  
            task4kernel2fpu ['CODE4C']        = {} 
            task4kernel2fpu ['CODE4CL']       = {} 
                       
            task4kernel2fpu ['CODE4PYC']      = {}                                                                  
            task4kernel2fpu ['CODE4BIN']      = {}
 
            task4kernel2fpu ['DIRECTORY4PY']  = {}                                                                  
            task4kernel2fpu ['DIRECTORY4CPP'] = {}
            task4kernel2fpu ['DIRECTORY4C']   = {}
            task4kernel2fpu ['DIRECTORY4CL']  = {}
                                                                                                       
            task4kernel2fpu ['DIRECTORY4PYC'] = {}                                                                  
            task4kernel2fpu ['DIRECTORY4BIN'] = {}                                                                  
                                               
            # ---------------------------------------------------------------------------------------------
            # (12A0) DIRECTORY4PY - PYTHON                 
            # ---------------------------------------------------------------------------------------------             
            dir2py4fpu = folder2lib4fpu                                                                                                                                                            
            message2print = "{(Step 12A0/70) set" + "; dir2py4fpu-set-by-create2kernel4fpu to: " + str(dir2py4fpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4fpu 
            code2ack  = code2ack + '12A0-' 
        
            task4kernel2fpu ['DIRECTORY4PY'] = dir2py4fpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A0) CODE4PY - PYTHON         
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A0/70) using" + "; DirectoryWalker-using-by-create2kernel4fpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2py4fpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B0/70) examining" + "; directory-examining-by-create2kernel4fpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C0/70) examining" + "; file-examining-by-create2kernel4fpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4fpu + fpu2sampler4xi5test.py; fpu2dummy4xi5test.cpp 
                    
                    message2print = "{(Step 14D0/70) calling" + "; fetch2kernel4fpu-calling-by-create2kernel4fpu: " + str(fetch2kernel4fpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4fpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E0/70) passing" + "; file2walk-passing-to-fetch2kernel4fpu-by-create2kernel4fpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4fpu + fpu2sampler4xi5test.py; fpu2dummy4xi5test.cpp 
                    
                    fetch2kernel4fpu(file2walk)                                                                     # FETCHES KERNEL FILES INTO FETCH2CODE4FPU DICTIONARY 
                    
                    message2print = "{(Step 14E0/70) performed" + "; fetch2kernel4fpu-performed-by-create2kernel4fpu: " + str(fetch2kernel4fpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4fpu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14F0/70) got" + "; fetch2code4fpu-got-by-create2kernel4fpu: " + str(fetch2code4fpu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # ...  {1: '...profile = "11" />\n', 2: '# --
            
            
                     
            keys2explore4fpu = fetch2code4fpu.keys()
            message2print = "{(Step 14G0/70) using" + "; keys2explore4fpu-using-by-create2kernel4fpu: " + str(keys2explore4fpu) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)             
            # folder2lib4fpu + fpu2sampler4xi5test.py; fpu2dummy4xi5test.cpp
            
            for key2explore4fpu in keys2explore4fpu:
                name2program4fpu=os.path.splitext(key2explore4fpu)                                                  # fpu2sampler4xi5test + py
                key2extension4fpu = name2program4fpu[1]                                                              
                if key2extension4fpu == '.py':                          
                    task4kernel2fpu ['CODE4PY'] [key2explore4fpu] = fetch2code4fpu[key2explore4fpu]                 # Python code(s)      

            # ---------------------------------------------------------------------------------------------
            # (14H0) SIZE4PY - PYTHON SOURCE            
            # ---------------------------------------------------------------------------------------------                                                
            size2py4fpu  = {}
            keys2py4fpu = fetch2code4fpu.keys()                                                                     # fpu2sampler4xi5test.py
            for key2py4fpu in keys2py4fpu:
                name2program4fpu=os.path.splitext(key2py4fpu)                                                       # fpu2sampler4xi5test + py
                key2extension4fpu = name2program4fpu[1]                                                             # py   
                if key2extension4fpu == '.py':                          
                    size2py4fpu[key2py4fpu] = len(fetch2code4fpu[key2py4fpu])                                       # length of saved py code 

            task4kernel2fpu ['SIZE4PY'] = size2py4fpu
                               
            message2print = "{(Step 14H0/70) set" + "; size2py4fpu-set-by-create2kernel4fpu to: " + str(size2py4fpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {folder2lib4fpu + fpu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '14H1-' 
            

            # ---------------------------------------------------------------------------------------------
            # (12A1) C, C++, CL SOURCE                   
            # ---------------------------------------------------------------------------------------------             
            dir2c4fpu = folder2lib4fpu                                                                                                                                                            
            message2print = "{(Step 12A1/70) set" + "; dir2c4fpu-set-by-create2kernel4fpu to: " + str(dir2c4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # folder2lib4fpu 
            code2ack  = code2ack + '12A1-' 
        
            task4kernel2fpu ['DIRECTORY4CPP']  = dir2c4fpu
            task4kernel2fpu ['DIRECTORY4C']    = dir2c4fpu
            task4kernel2fpu ['DIRECTORY4CLPP'] = dir2c4fpu
            task4kernel2fpu ['CODE4CPP'] = {} 
            task4kernel2fpu ['CODE4C']   = {} 
            task4kernel2fpu ['CODE4CL']  = {}            
            
            # ---------------------------------------------------------------------------------------------
            # (14A1) C, C++, CL SOURCE   
            # ---------------------------------------------------------------------------------------------             
            keys2c4fpu = fetch2code4fpu.keys()
            for key2c4fpu in keys2c4fpu:
                name2c4fpu=os.path.splitext(key2c4fpu)                                                  
                key2extension4fpu = name2c4fpu[1]                                                             # C++, C, CL 
                if key2extension4fpu == '.cpp':                          
                    task4kernel2fpu ['CODE4CPP'] [key2c4fpu] = fetch2code4fpu[key2c4fpu]                     
                    message2print = "{(Step 14G1/70) set" + "; key2c4fpu-set-by-create2kernel4fpu to: " + str(key2c4fpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4fpu + fpu2dummy4xi5test.cpp
                if key2extension4fpu == '.c':                          
                    task4kernel2fpu ['CODE4C'] [key2c4fpu] = fetch2code4fpu[key2c4fpu]                     
                    message2print = "{(Step 14G2/70) set" + "; key2c4fpu-set-by-create2kernel4fpu to: " + str(key2c4fpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4fpu +
                if key2extension4fpu == '.cl':                          
                    task4kernel2fpu ['CODE4CL'] [key2c4fpu] = fetch2code4fpu[key2c4fpu]                     
                    message2print = "{(Step 14G3/70) set" + "; key2c4fpu-set-by-create2kernel4fpu to: " + str(key2c4fpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4fpu + 
                                                                
            # ----------------------------------------------------------------------------------------------
            # (14H1) SIZE4C - C C++ CL SOURCE HAS THE SAME FOLDER AS FOR PYTHON SOURCE - ALREADY FETCHED           
            # ----------------------------------------------------------------------------------------------                                                
            size2c4fpu  = {}
            keys2c4fpu = fetch2code4fpu.keys()                                                                # 
            for key2c4fpu in keys2c4fpu:
                name2program4fpu=os.path.splitext(key2c4fpu)                                                  # 
                key2extension4fpu = name2program4fpu[1]                                                       #    
                if key2extension4fpu == '.cpp':                          
                    size2c4fpu[key2c4fpu] = len(fetch2code4fpu[key2c4fpu])                                    # length of saved C++ code
                    task4kernel2fpu ['SIZE4CPP'] = size2c4fpu 
                if key2extension4fpu == '.c':                          
                    size2c4fpu[key2c4fpu] = len(fetch2code4fpu[key2c4fpu])                                    # length of saved C code
                    task4kernel2fpu ['SIZE4C'] = size2c4fpu
                if key2extension4fpu == '.cl':                          
                    size2c4fpu[key2c4fpu] = len(fetch2code4fpu[key2c4fpu])                                    # length of saved CL code
                    task4kernel2fpu ['SIZE4CL'] = size2c4fpu 
                                       
            
                               
            message2print = "{(Step 14H1/70) set" + "; size2c4fpu-set-by-create2kernel4fpu to: " + str(size2c4fpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # folder2lib4fpu + fpu2dummy4xi5test.cpp': 331}
            code2ack  = code2ack + '14H1-' 
            
                                                  
            # ---------------------------------------------------------------------------------------------
            # (12B2) DIRECTORY FOR PYTHON CACHE - REQUIRED                      
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4fpu = folder2lib4fpu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 12B2/70) set" + "; dir2pycache4fpu-set-by-create2kernel4fpu to: " + str(dir2pycache4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4fpu + '__pycache__//'
            code2ack  = code2ack + '12B2-' 
        
            task4kernel2fpu ['DIRECTORY4PYC'] = dir2pycache4fpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A2) CODE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A2/70) using" + "; DirectoryWalker-using-by-create2kernel4fpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2pycache4fpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B2/70) examining" + "; directory-examining-by-create2kernel4fpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C2/70) examining" + "; file-examining-by-create2kernel4fpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4fpu + __pycache__//fpu2sampler4xi5test.cpython-33.pyc
                    
                    message2print = "{(Step 14D2/70) calling" + "; fetch2kernel4fpu-calling-by-create2kernel4fpu: " + str(fetch2kernel4fpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4fpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E2/70) passing" + "; file2walk-passing-to-fetch2kernel4fpu-by-create2kernel4fpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4fpu + __pycache__//fpu2sampler4xi5test.cpython-33.pyc
                    
                    fetch2kernel4fpu(file2walk)                                                                     # fetches kernel files into fetch2code4fpu dictionary 
                    
                    message2print = "{(Step 14F2/70) performed" + "; fetch2kernel4fpu-performed-by-create2kernel4fpu: " + str(fetch2kernel4fpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4fpu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14G2/70) got" + "; fetch2code4fpu-got-by-create2kernel4fpu: " + str(fetch2code4fpu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # 
            
            task4kernel2fpu ['CODE4PYC'] = {}
            keys2pyc4fpu = fetch2code4fpu.keys()
            for key2pyc4fpu in keys2pyc4fpu:
                name2program4fpu=os.path.splitext(key2pyc4fpu)                                                      # fpu2sampler4xi5test.cpython-33.pyc
                key2extension4fpu = name2program4fpu[1]                                                             # pyc 
   
                if key2extension4fpu == '.pyc':                          
                    task4kernel2fpu ['CODE4PYC'] [key2pyc4fpu] = fetch2code4fpu[key2pyc4fpu]                        # binary code(s)
                    message2print = "{(Step 14H2/70) set" + "; key2pyc4fpu-set-by-create2kernel4fpu to: " + str(key2pyc4fpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    #    
                                     
            size2pyc4fpu  = {}

            for key2pyc4fpu in keys2pyc4fpu:
                name2program4fpu=os.path.splitext(key2pyc4fpu)                                                      # fpu2sampler4xi5test.cpython-32 + pyc
                key2extension4fpu = name2program4fpu[1]                                                             # pyc 
                if key2extension4fpu == '.pyc':                          
                    size2pyc4fpu[key2pyc4fpu] = len(fetch2code4fpu[key2pyc4fpu])                                    # length of saved binary code
                    message2print = "{(Step 14I2/70) set" + "; key2pyc4fpu-set-by-create2kernel4fpu to: " + str(key2pyc4fpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # 
                                              
            # ---------------------------------------------------------------------------------------------
            # (14I2) SIZE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2fpu ['SIZE4PYC'] = size2pyc4fpu
                               
            message2print = "{(Step 14J2/70) set" + "; size2pyc4fpu-set-by-create2kernel4fpu to: " + str(size2pyc4fpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 
            code2ack  = code2ack + '14J2-' 

                                               
            # ---------------------------------------------------------------------------------------------
            # (12A3) DIRECTORY FOR C++, C, CL BIN - REQUIRED                    
            # ---------------------------------------------------------------------------------------------             
            dir2bin4fpu = folder2lib4fpu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4fpu-set-by-create2kernel4fpu to: " + str(dir2bin4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4fpu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2fpu ['DIRECTORY4BIN'] = dir2bin4fpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A3) CODE4BIN FOR C++, C, CL - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A3/70) using" + "; DirectoryWalker-using-by-create2kernel4fpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2bin4fpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B3/70) examining" + "; directory-examining-by-create2kernel4fpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C3/70) examining" + "; file-examining-by-create2kernel4fpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4fpu + bin//fpu2dummy4xi5test.exe
                    
                    message2print = "{(Step 14D3/70) calling" + "; fetch2kernel4fpu-calling-by-create2kernel4fpu: " + str(fetch2kernel4fpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4fpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E3/70) passing" + "; file2walk-passing-to-fetch2kernel4fpu-by-create2kernel4fpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4fpu + bin//fpu2dummy4xi5test.exe
                    
                    fetch2kernel4fpu(file2walk)                                                                     # fetches kernel files into fetch2code4fpu dictionary 
                    
                    message2print = "{(Step 14E3/70) performed" + "; fetch2kernel4fpu-performed-by-create2kernel4fpu: " + str(fetch2kernel4fpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4fpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14F3/70) got" + "; fetch2code4fpu-got-by-create2kernel4fpu: " + str(fetch2code4fpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # 

            task4kernel2fpu ['CODE4BIN'] = {}
            
            keys2bin4fpu = fetch2code4fpu.keys()
            message2print = "{(Step 14G3/70) using" + "; keys2bin4fpu-using-by-create2kernel4fpu: " + str(keys2bin4fpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4fpu + 'fpu2dummy4xi5test.cpp', 'fpu2sampler4xi5test.py']
            
            for key2bin4fpu in keys2bin4fpu:
                name2program4fpu=os.path.splitext(key2bin4fpu)                                                      # fpu2dummy4xi5test.exe
                key2extension4fpu = name2program4fpu[1]                                                             # bin 
   
                if key2extension4fpu == '.exe':                          
                    task4kernel2fpu ['CODE4BIN'] [key2bin4fpu] = fetch2code4fpu[key2bin4fpu]                        # binary code(s)   
                                        
            size2bin4fpu  = {}
            keys2bin4fpu = fetch2code4fpu.keys()                                                                    # fpu2dummy4xi5test.exe
            for key2bin4fpu in keys2bin4fpu:
                name2program4fpu=os.path.splitext(key2bin4fpu)                                                      # fpu2sampler4xi5test.cpython-32 + bin
                key2extension4fpu = name2program4fpu[1]                                                             # bin 
                if key2extension4fpu == '.exe':                          
                    size2bin4fpu[key2bin4fpu] = len(fetch2code4fpu[key2bin4fpu])                                    # length of saved binary code
                        
            # ---------------------------------------------------------------------------------------------
            # (14H3) SIZE4BIN - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2fpu ['SIZE4BIN'] = size2bin4fpu
                               
            message2print = "{(Step 14H3/70) set" + "; size2bin4fpu-set-by-create2kernel4fpu to: " + str(size2bin4fpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {}
            code2ack  = code2ack + '14H3-' 

            # ---------------------------------------------------------------------------------------------
            # (14J) COUNT4PY, COUNT4C,COUNT4PYC,COUNT4BIN                
            # ---------------------------------------------------------------------------------------------             
            task4kernel2fpu ['COUNT4PY']     = 0
            task4kernel2fpu ['COUNT4CPP']    = 0
            task4kernel2fpu ['COUNT4C']      = 0
            task4kernel2fpu ['COUNT4CL']     = 0
            task4kernel2fpu ['COUNT4PYC']    = 0
            task4kernel2fpu ['COUNT4BIN']    = 0

            keys2code4fpu = fetch2code4fpu.keys()
            message2print = "{(Step 14J/70) using" + "; keys2code4fpu-using-by-create2kernel4fpu: " + str(keys2code4fpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4fpu + 'fpu2dummy4xi5test.cpp', folder2lib4fpu + 'fpu2sampler4xi5test.py']

            
            for key2code4fpu in keys2code4fpu:
                name2program4fpu=os.path.splitext(key2code4fpu)                                                    
                key2extension4fpu = name2program4fpu[1]                                                             
                if key2extension4fpu == '.py':                          
                    task4kernel2fpu ['COUNT4PY']     = task4kernel2fpu ['COUNT4PY']  + 1 
                if key2extension4fpu == '.cpp':                          
                    task4kernel2fpu ['COUNT4CPP']    = task4kernel2fpu ['COUNT4CPP'] + 1                                            
                if key2extension4fpu == '.c':                          
                    task4kernel2fpu ['COUNT4C']      = task4kernel2fpu ['COUNT4C']   + 1              
                if key2extension4fpu == '.cl':                          
                    task4kernel2fpu ['COUNT4CL']     = task4kernel2fpu ['COUNT4CL']  + 1                                  
                if key2extension4fpu == '.pyc':                          
                    task4kernel2fpu ['COUNT4PYC']    = task4kernel2fpu ['COUNT4PYC'] + 1                            
                if key2extension4fpu == '.exe':                          
                    task4kernel2fpu ['COUNT4BIN']    = task4kernel2fpu ['COUNT4BIN'] + 1                                                                                 
            
            message2print = "{(Step 14K/70) set" + "; count4py-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['COUNT4PY'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            
            message2print = "{(Step 14L/70) set" + "; count4cpp-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['COUNT4CPP'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            message2print = "{(Step 14M/70) set" + "; count4c-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['COUNT4C'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0 
            message2print = "{(Step 14N/70) set" + "; count4cl-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['COUNT4CL'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                         
            
            message2print = "{(Step 14M/70) set" + "; count4pyc-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['COUNT4PYC'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0
            
            message2print = "{(Step 14N/70) set" + "; count4bin-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['COUNT4BIN'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                                                
            code2ack  = code2ack + '14N-'
            
            # ---------------------------------------------------------------------------------------------
            # (15) LANGUAGE - EXTRA                             
            # ---------------------------------------------------------------------------------------------             
            task4kernel2fpu ['LANGUAGE'] = {}
            
            for key2code4fpu in keys2code4fpu:
                name2program4fpu=os.path.splitext(key2code4fpu)                                                     
                key2extension4fpu = name2program4fpu[1]                                                             
                if key2extension4fpu == '.py':                          
                    task4kernel2fpu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4fpu == '.cpp':                          
                    task4kernel2fpu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4fpu == '.c':                          
                    task4kernel2fpu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4fpu == '.cl':                          
                    task4kernel2fpu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4fpu-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '15B-' 
                      
            # ---------------------------------------------------------------------------------------------
            # (16) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            count2reference2fpu  = 1
           
            message2print = "{(Step 16B/70) set" + "; count2reference2fpu-set-by-create2kernel4fpu to: " + str(count2reference2fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '16B-' 
        
            task4kernel2fpu ['COUNT2REFERENCE'] = count2reference2fpu                                 
                                    
            # ---------------------------------------------------------------------------------------------
            # (17) PROGRAM - REQUIRED                           
            # ---------------------------------------------------------------------------------------------             
            task4kernel2fpu ['PROGRAM'] = None
            message2print = "{(Step 17A/70) try" + "; program2fpu-try-by-create2kernel4fpu: " + str(task4kernel2fpu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2fpu ['PROGRAM'] = create2programwithsource4fpu()
                keys2program = task4kernel2fpu ['PROGRAM'].keys()
                
                message2print = "{(Step 17B/70) set" + "; program-set-by-create2kernel4fpu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'COUNT2REFERENCE', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '17B-'
            except:
                message2print = "{(Step 17Z1/70) failed" + "; task4kernel2fpu-failed-by-create2kernel4fpu: " + str(task4kernel2fpu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '17Z-'
                                    
            # ---------------------------------------------------------------------------------------------
            # (18) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2fpu ['FUNCTION'] = {}
            message2print = "{(Step 18A0/70) set" + "; function4fpu-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2fpu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 18A1/70) set" + "; pythonfunction4fpu-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4fpu  = kb2kernel4fpu ['.py'] ['TAG']
            message2print = "{(Step 18A2/70) using" + "; tag2search4fpu-using-by-create2kernel4fpu: " + str(tag2search4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4fpu    = kb2kernel4fpu ['.py'] ['VALUE']
            message2print = "{(Step 18A3/70) using" + "; value2search4fpu-using-by-create2kernel4fpu: " + str(value2search4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # fpu2sampler4xi5test
            
            attribute2search4fpu= kb2kernel4fpu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 18A4/70) using" + "; attribute2search4fpu-using-by-create2kernel4fpu: " + str(attribute2search4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4fpu in keys2code4fpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4fpu]
                    keys2line4fpu = code2examine4fpu.keys()
                    for key2line4fpu in keys2line4fpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4fpu] [key2line4fpu]
                        # message2print = "{(Step 18A5/70) examining" + "; line2examine4fpu-examining-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4fpu,tag2search4fpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 18B/70) examining" + "; line2function4fpu-examining-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # <... fpu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4fpu,value2search4fpu)
                            if index2function == -1:
                                message2print = "{(Step 18C/70) skipped" + "; line2function4fpu-skipped-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # <... set2trace4sampler" ... # ...function = "fpu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4fpu,attribute2search4fpu)             # ...function = "fpu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 18D/70) warning" + "; line2function4fpu-warning-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 18E/70) accepted" + "; line2examine4fpu-accepted-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ...function = "fpu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4fpu = line2examine4fpu[index2function:index2usage-2]
                                    
                                    task4kernel2fpu ['FUNCTION'] ['.py'] [key2pythonfunction4fpu] = {}                                  

                                    message2print = "{(Step 18F/70) used" + "; key2pythonfunction4fpu-used-by-create2kernel4fpu: " + str(key2pythonfunction4fpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # fpu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '18F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 18Z1/70) failed" + "; task4kernel2fpu-failed-by-create2kernel4fpu: " + str(task4kernel2fpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '18Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (19) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2fpu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 19A0F/70) set" + "; cplusfunction4fpu-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4fpu      = kb2kernel4fpu ['.cpp'] ['TAG']
            message2print = "{(Step 19A2/70) using" + "; tag2search4fpu-using-by-create2kernel4fpu: " + str(tag2search4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <...            
            attribute2search4fpu= kb2kernel4fpu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 19A4/70) using" + "; attribute2search4fpu-using-by-create2kernel4fpu: " + str(attribute2search4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4fpu in keys2code4fpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4fpu]
                    message2print = "{(Step 19A5/70) using" + "; key2code4fpu-using-by-create2kernel4fpu: " + str(key2code4fpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # fpu2dummy4xi5test.cpp
                       
                    keys2line4fpu = code2examine4fpu.keys()
                    # message2print = "{(Step 19A6/70) using" + "; keys2line4fpu-using-by-create2kernel4fpu: " + str(keys2line4fpu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4fpu in keys2line4fpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4fpu] [key2line4fpu]
                        # message2print = "{(Step 19A7/70) examining" + "; line2examine4fpu-examining-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # /*<... nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4fpu,tag2search4fpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 19B1/70) examining" + "; line2function4fpu-examining-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # ... function = "OCLError" usage = "error code checking"*/
                            # ... function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 19B2/70) using" + "; attribute2search4fpu-using-by-create2kernel4fpu: " + str(attribute2search4fpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4fpu,attribute2search4fpu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 19C/70) skipped" + "; line2function4fpu-skipped-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 19E/70) accepted" + "; line2examine4fpu-accepted-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "nbody_kern" usage = "kernel example 1"*/; 
                                # ... function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4fpu = line2examine4fpu[27:index2usage-2]  
                                task4kernel2fpu ['FUNCTION'] ['.cpp'] [key2kernelfunction4fpu] =  {}                                       

                                message2print = "{(Step 19F/70) used" + "; key2kernelfunction4fpu-used-by-create2kernel4fpu: " + str(key2kernelfunction4fpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '19F-'
                                    
                                    
            except:
                message2print = "{(Step 19Z1/70) failed" + "; task4kernel2fpu-failed-by-create2kernel4fpu: " + str(task4kernel2fpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #   
                #             
                code2nack  = code2nack + '19Z-'           
                                                      
            # ---------------------------------------------------------------------------------------------
            # EOF CREATING TASK4KERNEL2FPU                  
            # ---------------------------------------------------------------------------------------------                                                                                                                                                          
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernel2fpu-yielded-by-create2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-' 

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4kernel2fpu.keys()        
    message2print = "{(Step 19A/70) using" + "; keys2task-using-by-create2kernel4fpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    #1 this program created:
    # ['BUFFER'  ... 'LANGUAGE', 'PIPE', 
    #  'PLATFORM', 'PROGRAM', 'QUEUE' ....']
    #2 caller passed:
    # ['FUNCTION', 'PROGRAM']
    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - CREATE PROGRAM OBJECT FOR FPU - BUILD REQUIRED ONES IF USER HAS FORGOTTEN ! 
    # ---------------------------------------------------------------------------------------------    
    fpu2kernel4xi = {}                                                                                             # CREATE INITIALIZES DICTIONARY!                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; fpu2kernel4xi-initialized-by-create2kernel4fpu to: " + str(fpu2kernel4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    if (('DATA2CALLBACK' not in keys2task) or ('FUNCTION2CALLBACK' not in keys2task)):
        try:            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - REQUIRED                
            # ---------------------------------------------------------------------------------------------
                     
            function2callback4fpu = trace2kernel4fpu                                                                # CALLBACK FUNCTION FOR FPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4fpu-created-by-create2kernel4fpu: " + str(function2callback4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4fpu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4fpu"                                                          # MODULE OF FPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4fpu"                                                          # FUNCTION OF FPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4fpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR FPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4fpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4fpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4fpu',
            #  'METHOD': 'create2kernel4fpu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2fpu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO FPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2fpu['FUNCTION2CALLBACK'] = function2callback4fpu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2fpu-created-by-create2kernel4fpu: " + str(task4kernel2fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4fpu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4fpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4fpu',
            #  'METHOD': 'create2kernel4fpu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}
        except: 
            message2print = "{(Step 1Z2/70) yielded" + "; callbacks-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'     
                
    if 'DATA2CALLBACK' in keys2task:
        message2print = "{(Step 21A0/70) try" + "; data2callback-try-by-create2kernel4fpu: {}" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21A/70) - DATA2CALLBACK - REQUIRED 
            # -----------------------------------------------------------------------------------------               
            fpu2kernel4xi['DATA2CALLBACK'] = task4kernel2fpu['DATA2CALLBACK']
            
            message2print = "{(Step 21A1/70) initialized" + "; data2callback-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4fpu-failed ; time: 04:42:53 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4fpu',
            #  'METHOD': 'create2kernel4fpu'}
    
            code2ack  = code2ack + '21A1-'
        except: 
            message2print = "{(Step 21Z1/70) yielded" + "; data2callback-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '21Z1-'
    
    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22B/70) - FUNCTION2CALLBACK - REQUIRED
            # -----------------------------------------------------------------------------------------               
            fpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernel2fpu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 22B1/70) initialized" + "; function2callback-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2kernel4fpu at 0x000000000422F6C8>
            
            code2ack  = code2ack + '22B1-'
        except: 
            message2print = "{(Step 22Z2/70) yielded" + "; function2callback-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z2-' 
        
        message2print = "{(Step 22C0/70) try" + "; platform-try-by-create2kernel4fpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #

        
    if 'PLATFORM' in keys2task:         
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22C/70) - PLATFORM - EXTRA
            # -----------------------------------------------------------------------------------------               
            fpu2kernel4xi['PLATFORM'] = task4kernel2fpu['PLATFORM']
            
            message2print = "{(Step 22C1/70) initialized" + "; platform-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    
    
            code2ack  = code2ack + '22C1-'
        except: 
            message2print = "{(Step 22Z3/70) yielded" + "; platform-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z3-' 
            
    
    if 'CONTEXT' in keys2task:        
        message2print = "{(Step 23A/70) try" + "; context2fpu-try-by-create2kernel4fpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 23/70) - CONTEXT  - EXTRA
            # -----------------------------------------------------------------------------------------               
            fpu2kernel4xi['CONTEXT'] = task4kernel2fpu['CONTEXT']
            
            message2print = "{(Step 23B/70) initialized" + "; context-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...      
            
            code2ack  = code2ack + '23B-'
        except: 
            message2print = "{(Step 23Z1/70) yielded" + "; context-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        
            code2nack  = code2nack + '23Z1-' 
    
    if 'DEVICE' in keys2task:        
        message2print = "{(Step 24A/70) try" + "; device-try-by-create2kernel4fpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 24/70) - DEVICE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            fpu2kernel4xi['DEVICE'] = task4kernel2fpu['DEVICE']
            
            message2print = "{(Step 24B/70) initialized" + "; device-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
            
            code2ack  = code2ack + '24B-'
        except: 
            message2print = "{(Step 24Z1/70) yielded" + "; device-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '24Z1-'
    
    if 'CODE2ERROR' in keys2task:                     
        message2print = "{(Step 25A/70) try" + "; code2error-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 25/70) - ERROR CODE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            fpu2kernel4xi['CODE2ERROR'] = task4kernel2fpu['CODE2ERROR']
            
            message2print = "{(Step 25B/70) initialized" + "; code2error-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '25B-'
        except: 
            message2print = "{(Step 25Z1/70) yielded" + "; code2error-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '25Z1-'
                            
    if 'QUEUE' not in keys2task: 
        try:
            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - REQUIRED                          
            # ---------------------------------------------------------------------------------------------         
            queue2fpu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2fpu-trying-by-create2kernel4fpu: " + str(queue2fpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2fpu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2fpu-got-by-create2kernel4fpu: " + str(queue2fpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2fpu-failed-by-create2kernel4fpu: " + str(queue2fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2fpu ['QUEUE'] = queue2fpu
        except:
            message2print = "{(Step 26Z1/70) yielded" + "; queue-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z1-'             

    if 'QUEUE' in keys2task:          
        message2print = "{(Step 26A/70) try" + "; queue-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 26/70) - QUEUE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            fpu2kernel4xi['QUEUE'] = task4kernel2fpu['QUEUE']
            
            message2print = "{(Step 26B/70) initialized" + "; queue-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <queue4xi.Queue4Xi object at 0x0000000003E72828> 
            
            code2ack  = code2ack + '26B-'
        except: 
            message2print = "{(Step 26Z2/70) yielded" + "; queue-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z2-' 
              
    if 'PIPE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------         
            pipe2fpu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2fpu-trying-by-create2kernel4fpu: " + str(pipe2fpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2fpu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2fpu-got-by-create2kernel4fpu: " + str(pipe2fpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2fpu-failed-by-create2kernel4fpu: " + str(pipe2fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2fpu ['PIPE'] = pipe2fpu 
        except: 
            message2print = "{(Step 27Z1/70) yielded" + "; pipe-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z1-'
                                 
    if 'PIPE' in keys2task:                                
        message2print = "{(Step 27A/70) try" + "; pipe-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 27/70) - PIPE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            fpu2kernel4xi['PIPE'] = task4kernel2fpu['PIPE']
            
            message2print = "{(Step 27B/70) initialized" + "; pipe-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
            
            code2ack  = code2ack + '27B-'
        except: 
            message2print = "{(Step 27Z2/70) yielded" + "; pipe-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z2-' 

    if 'COMMANDQUEUE' in keys2task:
        message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-create2kernel4fpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (28) COMMAND QUEUE - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            fpu2kernel4xi['COMMANDQUEUE']  = task4kernel2fpu['COMMANDQUEUE']  
     
            message2print = "{(Step 28B/70) initialized" + "; commandqueue-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                    
            code2ack  = code2ack + '28B-'
        except: 
            message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
                  
            code2nack  = code2nack + '28Z1-'    
    
    if 'BUFFER' in keys2task:
        message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-create2kernel4fpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (29) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            fpu2kernel4xi['BUFFER']  = task4kernel2fpu['BUFFER']  
     
            message2print = "{(Step 29B/70) initialized" + "; bufferinfo-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
            
            
            code2ack  = code2ack + '29B-'
        except: 
            message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '29Z1-'            
    
    if 'EVENT' in keys2task:
        message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-create2kernel4fpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (30) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            fpu2kernel4xi['EVENT']  = task4kernel2fpu['EVENT']  
     
            message2print = "{(Step 30B/70) initialized" + "; eventinfo-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'DATA2CALLBACK' ... 
            
            code2ack  = code2ack + '30B-'
        except: 
            message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '30Z1-'
                        
    
    if 'COUNT4PY' in keys2task:               
        message2print = "{(Step 31A1/70) try" + "; count2py4fpu-try-by-create2kernel4fpu: " + str(task4kernel2fpu['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PY - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['COUNT4PY']  = task4kernel2fpu['COUNT4PY']  
    
            message2print = "{(Step 31A2/70) initialized" + "; count2py4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31A2-'
        except: 
            message2print = "{(Step 31Z1/70) yielded" + "; count2py4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z1-'     
    
    if 'COUNT4CPP' in keys2task:               
        message2print = "{(Step 31B1/70) try" + "; count2cpp4fpu-try-by-create2kernel4fpu: " + str(task4kernel2fpu['COUNT4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CPP - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['COUNT4CPP']  = task4kernel2fpu['COUNT4CPP']  
    
            message2print = "{(Step 31B2/70) initialized" + "; count2cpp4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['COUNT4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31B2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cpp4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
            
    
    if 'COUNT4C' in keys2task:               
        message2print = "{(Step 31C1/70) try" + "; count2c4fpu-try-by-create2kernel4fpu: " + str(task4kernel2fpu['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4C - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['COUNT4C']  = task4kernel2fpu['COUNT4C']  
    
            message2print = "{(Step 31C2/70) initialized" + "; count2c4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31C2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2c4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
    
    if 'COUNT4CL' in keys2task:               
        message2print = "{(Step 31D1/70) try" + "; count2cl4fpu-try-by-create2kernel4fpu: " + str(task4kernel2fpu['COUNT4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CL - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['COUNT4CL']  = task4kernel2fpu['COUNT4CL']  
    
            message2print = "{(Step 31D2/70) initialized" + "; count2cl4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['COUNT4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31D2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cl4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
                
    if 'COUNT4PYC' in keys2task:               
        message2print = "{(Step 31E1/70) try" + "; count4pyc-try-by-create2kernel4fpu: " + str(task4kernel2fpu['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PYC - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['COUNT4PYC']  = task4kernel2fpu['COUNT4PYC']  
    
            message2print = "{(Step 31E2/70) initialized" + "; count4pyc-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '31E2-'
        except: 
            message2print = "{(Step 31Z4/70) yielded" + "; count4pyc-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z4-'     
    
    if 'COUNT4BIN' in keys2task:               
        message2print = "{(Step 31F1/70) try" + "; count4bin-try-by-create2kernel4fpu: " + str(task4kernel2fpu['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4BIN - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['COUNT4BIN']  = task4kernel2fpu['COUNT4BIN']  
    
            message2print = "{(Step 31F2/70) initialized" + "; count4bin-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 0
            code2ack  = code2ack + '31F2-'
        except: 
            message2print = "{(Step 31Z5/70) yielded" + "; count4bin-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z5-' 
                            
    if 'DIRECTORY4PY' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A) DIRECTORY4PY - REQUIRED                
            # ---------------------------------------------------------------------------------------------             
            dir2py4fpu = folder2lib4fpu                                                                                                                                                            
            message2print = "{(Step 32A/70) set" + "; dir2py4fpu-set-by-create2kernel4fpu to: " + str(dir2py4fpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4fpu 
            code2ack  = code2ack + '32A-' 
        
            task4kernel2fpu ['DIRECTORY4PY'] = dir2py4fpu
        except: 
            message2print = "{(Step 32AZ/70) yielded" + "; directory4py-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32AZ-'                         
               
    if 'DIRECTORY4PY' in keys2task:
        message2print = "{(Step 32A1/70) try" + "; directory4py-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PY - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['DIRECTORY4PY']  = task4kernel2fpu['DIRECTORY4PY']  
     
            message2print = "{(Step 32B1/70) initialized" + "; directory2py4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4fpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z1/70) yielded" + "; directory2py4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CPP' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CPP - C++                 
            # ---------------------------------------------------------------------------------------------             
            dir2cpp4fpu = folder2lib4fpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cpp4fpu-set-by-create2kernel4fpu to: " + str(dir2cpp4fpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4fpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2fpu ['DIRECTORY4CPP'] = dir2cpp4fpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CPP' in keys2task:
        message2print = "{(Step 32A2/70) try" + "; directory2cpp4fpu-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CPP - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['DIRECTORY4CPP']  = task4kernel2fpu['DIRECTORY4CPP']  
     
            message2print = "{(Step 32B2/70) initialized" + "; directory2cpp4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4fpu
            code2ack  = code2ack + '32B2-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2cpp4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
                         
    if 'DIRECTORY4C' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4C - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2c4fpu = folder2lib4fpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2c4fpu-set-by-create2kernel4fpu to: " + str(dir2c4fpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4fpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2fpu ['DIRECTORY4C'] = dir2c4fpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4C' in keys2task:
        message2print = "{(Step 32A3/70) try" + "; directory2c4fpu-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4C - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['DIRECTORY4C']  = task4kernel2fpu['DIRECTORY4C']  
     
            message2print = "{(Step 32B3/70) initialized" + "; directory2c4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['DIRECTORY4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4fpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2c4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CL' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CL - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2cl4fpu = folder2lib4fpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cl4fpu-set-by-create2kernel4fpu to: " + str(dir2cl4fpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4fpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2fpu ['DIRECTORY4CL'] = dir2cl4fpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CL' in keys2task:
        message2print = "{(Step 32A4/70) try" + "; directory2cl4fpu-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CL - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['DIRECTORY4CL']  = task4kernel2fpu['DIRECTORY4CL']  
     
            message2print = "{(Step 32B4/70) initialized" + "; directory2cl4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['DIRECTORY4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4fpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z4/70) yielded" + "; directory2cl4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-'
              
    if 'DIRECTORY4PYC' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4PYC - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4fpu = folder2lib4fpu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 32B2/70) set" + "; dir2pycache4fpu-set-by-create2kernel4fpu to: " + str(dir2pycache4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4fpu + '__pycache__//'
            code2ack  = code2ack + '32B2-' 
        
            task4kernel2fpu ['DIRECTORY4PYC'] = dir2pycache4fpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'                     
                                                    
    if 'DIRECTORY4PYC' in keys2task:
        message2print = "{(Step 32C/70) try" + "; directory2pyc4fpu-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PYC - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['DIRECTORY4PYC']  = task4kernel2fpu['DIRECTORY4PYC']  
     
            message2print = "{(Step 32D/70) initialized" + "; directory2pyc4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4fpu + __pycache__//
            code2ack  = code2ack + '32D-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z2-' 
             
    if 'DIRECTORY4BIN' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4BIN - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2bin4fpu = folder2lib4fpu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4fpu-set-by-create2kernel4fpu to: " + str(dir2bin4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4fpu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2fpu ['DIRECTORY4BIN'] = dir2bin4fpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4bin-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-' 
                                        
    if 'DIRECTORY4BIN' in keys2task:
        message2print = "{(Step 32E/70) try" + "; directory2bin4fpu-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4BIN - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['DIRECTORY4BIN']  = task4kernel2fpu['DIRECTORY4BIN']  
     
            message2print = "{(Step 32F/70) initialized" + "; directory2bin4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4fpu + bin//
            code2ack  = code2ack + '32F-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2bin4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z3-'  
    
                     
    if 'CODE4PY' in keys2task:            
        message2print = "{(Step 33A1/70) try" + "; code2py4fputask-try-by-create2kernel4fpu: " + str(task4kernel2fpu ['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4fpu + 'fpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: ...
        
        fpu2kernel4xi['CODE4PY'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PY - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['CODE4PY'] = task4kernel2fpu ['CODE4PY']
    
     
            message2print = "{(Step 33B1/70) created" + "; code2py4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + 'fpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2:
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z1/70) yielded" + "; code2py4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE4PY']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2py4fpu2nack  = code2py4fpu2nack + '33Z1-'     
                     
    if 'CODE4CPP' in keys2task:            
        message2print = "{(Step 33A2/70) try" + "; code2cpp4fputask-try-by-create2kernel4fpu: " + str(len(task4kernel2fpu ['CODE4CPP']))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4fpu +  fpu2dummy4xi5test.cpp
        
        fpu2kernel4xi['CODE4CPP'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CPP - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['CODE4CPP'] = task4kernel2fpu ['CODE4CPP']
    
     
            message2print = "{(Step 33B2/70) created" + "; code2cpp4fpu-created-by-create2kernel4fpu: " + str(len(fpu2kernel4xi['CODE4CPP']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + fpu2dummy4xi5test.cpp
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2cpp4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE4CPP']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cpp4fpu2nack  = code2cpp4fpu2nack + '33Z2-'     
                     
    if 'CODE4C' in keys2task:            
        message2print = "{(Step 33A3/70) try" + "; code2c4fputask-try-by-create2kernel4fpu: " + str(task4kernel2fpu ['CODE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4fpu + 
        
        fpu2kernel4xi['CODE4C'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4C - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['CODE4C'] = task4kernel2fpu ['CODE4C']
    
     
            message2print = "{(Step 33B3/70) created" + "; code2c4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2c4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE4C']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2c4fpu2nack  = code2c4fpu2nack + '33Z3-'                             
                     
    if 'CODE4CL' in keys2task:            
        message2print = "{(Step 33A4/70) try" + "; code2cl4fputask-try-by-create2kernel4fpu: " + str(task4kernel2fpu ['CODE4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4fpu + 
        
        fpu2kernel4xi['CODE4CL'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CL - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['CODE4CL'] = task4kernel2fpu ['CODE4CL']
    
     
            message2print = "{(Step 33B4/70) created" + "; code2cl4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z4/70) yielded" + "; code2cl4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE4CL']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cl4fpu2nack  = code2cl4fpu2nack + '33Z1-'     
                                        
    if 'CODE4PYC' in keys2task:            
        message2print = "{(Step 33C/70) try" + "; code2pyc4fpu-try-by-create2kernel4fpu: " + str(task4kernel2fpu ['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4fpu + 
        
        fpu2kernel4xi['CODE4PYC'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['CODE4PYC'] = task4kernel2fpu ['CODE4PYC']
    
     
            message2print = "{(Step 33D/70) created" + "; code2pyc4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + 
             
            code2ack  = code2ack + '33D-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2pyc4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE4PYC']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2pyc4fpu2nack  = code2pyc4fpu2nack + '33Z2-'     
                            
    if 'CODE4BIN' in keys2task:            
        message2print = "{(Step 33E/70) try" + "; code2bin4fpu2bin4fpu-try-by-create2kernel4fpu: " + str(task4kernel2fpu ['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4fpu + 
        
        fpu2kernel4xi['CODE4BIN'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['CODE4BIN'] = task4kernel2fpu ['CODE4BIN']
    
     
            message2print = "{(Step 33F/70) created" + "; code2bin4fpu-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + 
             
            code2ack  = code2ack + '33F-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2bin4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi['CODE4BIN']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2bin4fpu2nack  = code2bin4fpu2nack + '33Z3-'     
            
    if 'SIZE4PY' in keys2task:        
        message2print = "{(Step 34A1/70) try" + "; size2py4fpu-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['SIZE4PY']  = task4kernel2fpu['SIZE4PY']  
     
            message2print = "{(Step 34B1/70) initialized" + "; size2py4fpu-initialized-by-create2kernel4fpu to: " + str(fpu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + 'fpu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z1/70) yielded" + "; size2py4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
            
    if 'SIZE4CPP' in keys2task:        
        message2print = "{(Step 34A2/70) try" + "; size2cpp4fpu-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['SIZE4CPP']  = task4kernel2fpu['SIZE4CPP']  
     
            message2print = "{(Step 34B2/70) initialized" + "; size2cpp4fpu-initialized-by-create2kernel4fpu to: " + str(fpu2kernel4xi['SIZE4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + fpu2dummy4xi5test.cpp': 333}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z2/70) yielded" + "; size2cpp4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4C' in keys2task:        
        message2print = "{(Step 34A3/70) try" + "; size2c4fpu-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['SIZE4C']  = task4kernel2fpu['SIZE4C']  
     
            message2print = "{(Step 34B3/70) initialized" + "; size2c4fpu-initialized-by-create2kernel4fpu to: " + str(fpu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size2c4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4CL' in keys2task:        
        message2print = "{(Step 34A4/70) try" + "; size2cl4fpu-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['SIZE4CL']  = task4kernel2fpu['SIZE4CL']  
     
            message2print = "{(Step 34B4/70) initialized" + "; size2cl4fpu-initialized-by-create2kernel4fpu to: " + str(fpu2kernel4xi['SIZE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size2cl4fpu-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
                                    
                        
    if 'SIZE4PYC' in keys2task:        
        message2print = "{(Step 34E/70) try" + "; size-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34F) SIZE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['SIZE4PYC']  = task4kernel2fpu['SIZE4PYC']  
     
            message2print = "{(Step 34F/70) initialized" + "; size-initialized-by-create2kernel4fpu to: " + str(fpu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + 
            code2ack  = code2ack + '34F-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z3-'     
            
    if 'SIZE4BIN' in keys2task:        
        message2print = "{(Step 34G/70) try" + "; size-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34G) SIZE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            fpu2kernel4xi['SIZE4BIN']  = task4kernel2fpu['SIZE4BIN']  
     
            message2print = "{(Step 34H/70) initialized" + "; size-initialized-by-create2kernel4fpu to: " + str(fpu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4fpu + 
            code2ack  = code2ack + '34H-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z4-'
                 
    if 'LANGUAGE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (35A0) LANGUAGE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2fpu ['LANGUAGE'] = {}
            
            for key2code4fpu in keys2code4fpu:
                name2program4fpu=os.path.splitext(key2code4fpu)                                                     
                key2extension4fpu = name2program4fpu[1]                                                             
                if key2extension4fpu == '.py':                          
                    task4kernel2fpu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4fpu == '.cpp':                          
                    task4kernel2fpu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4fpu == '.c':                          
                    task4kernel2fpu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4fpu == '.cl':                          
                    task4kernel2fpu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4fpu-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-' 
        except: 
            message2print = "{(Step 35Z0/70) yielded" + "; language-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z0-'
                                     
    if 'LANGUAGE' in keys2task:        
        message2print = "{(Step 35A/70) try" + "; language-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (35) LANGUAGE - PYTHON, C++, C, CL                              
            # ---------------------------------------------------------------------------------------------             
                            
            fpu2kernel4xi['LANGUAGE']  = task4kernel2fpu['LANGUAGE']  
     
            message2print = "{(Step 35B/70) initialized" + "; language-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-'
        except: 
            message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z1-'  
                     
    if 'COUNT2REFERENCE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (36A0) COUNT2REFERENCE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            count2reference2fpu  = 1
           
            message2print = "{(Step 36B/70) set" + "; count2reference2fpu-set-by-create2kernel4fpu to: " + str(count2reference2fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '36B-' 
        
            task4kernel2fpu ['COUNT2REFERENCE'] = count2reference2fpu     
        except: 
            message2print = "{(Step 36Z0/70) yielded" + "; count2reference2fpu-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z0-'             
                
    if 'COUNT2REFERENCE' in keys2task:                
        message2print = "{(Step 36A/70) try" + "; count2reference-try-by-create2kernel4fpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (36) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            fpu2kernel4xi['COUNT2REFERENCE']  = task4kernel2fpu['COUNT2REFERENCE']  
     
            message2print = "{(Step 36B/70) initialized" + "; count2reference-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '36B-'
        except: 
            message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z1-' 
                
    if 'PROGRAM' not in keys2task:
        message2print = "{(Step 37/70) warned" + "; keys2task4program-warned-by-create2kernel4fpu: " + " ** " + str(keys2task)  + " ** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:             
            # ---------------------------------------------------------------------------------------------
            # (37A0) PROGRAM - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2fpu ['PROGRAM'] = None
            message2print = "{(Step 37A/70) try" + "; program2fpu-try-by-create2kernel4fpu: " + str(task4kernel2fpu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2fpu ['PROGRAM'] = create2programwithsource4fpu()
                keys2program = task4kernel2fpu ['PROGRAM'].keys()
                
                message2print = "{(Step 37B/70) set" + "; program-set-by-create2kernel4fpu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'PROGRAM', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '37B-'
            except:
                message2print = "{(Step 37Z1/70) failed" + "; task4kernel2fpu-failed-by-create2kernel4fpu: " + str(task4kernel2fpu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '37Z-'    
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; program-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-' 
                            
    if 'PROGRAM' in keys2task:
        message2print = "{(Step 37A/70) try" + "; program-try-by-create2kernel4fpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (37) PROGRAM - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            fpu2kernel4xi['PROGRAM']  = task4kernel2fpu['PROGRAM']  
     
            message2print = "{(Step 37B/70) initialized" + "; program-created-by-create2kernel4fpu: " + str(len(fpu2kernel4xi['PROGRAM']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0 ... 
            
            code2ack  = code2ack + '37B-'
        except: 
            message2print = "{(Step 37Z1/70) yielded" + "; program-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z1-' 
                       
    if 'FUNCTION' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2fpu ['FUNCTION'] = {}
            message2print = "{(Step 38A0/70) set" + "; function4fpu-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2fpu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 38A1/70) set" + "; pythonfunction4fpu-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4fpu  = kb2kernel4fpu ['.py'] ['TAG']
            message2print = "{(Step 38A2/70) using" + "; tag2search4fpu-using-by-create2kernel4fpu: " + str(tag2search4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4fpu    = kb2kernel4fpu ['.py'] ['VALUE']
            message2print = "{(Step 38A3/70) using" + "; value2search4fpu-using-by-create2kernel4fpu: " + str(value2search4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # fpu2sampler4xi5test
            
            attribute2search4fpu= kb2kernel4fpu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 38A4/70) using" + "; attribute2search4fpu-using-by-create2kernel4fpu: " + str(attribute2search4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4fpu in keys2code4fpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4fpu]
                    keys2line4fpu = code2examine4fpu.keys()
                    for key2line4fpu in keys2line4fpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4fpu] [key2line4fpu]
                        # message2print = "{(Step 38A5/70) examining" + "; line2examine4fpu-examining-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4fpu,tag2search4fpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 38B/70) examining" + "; line2function4fpu-examining-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # function = "fpu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4fpu,value2search4fpu)
                            if index2function == -1:
                                message2print = "{(Step 38C/70) skipped" + "; line2function4fpu-skipped-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "set2trace4sampler" ... # function = "fpu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4fpu,attribute2search4fpu)             # ....function = "fpu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 38D/70) warning" + "; line2function4fpu-warning-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 38E/70) accepted" + "; line2examine4fpu-accepted-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ... function = "fpu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4fpu = line2examine4fpu[index2function:index2usage-2]
                                    
                                    task4kernel2fpu ['FUNCTION'] ['.py'] [key2pythonfunction4fpu] = {}                                  

                                    message2print = "{(Step 38F/70) used" + "; key2pythonfunction4fpu-used-by-create2kernel4fpu: " + str(key2pythonfunction4fpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # fpu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '38F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 38Z1/70) failed" + "; task4kernel2fpu-failed-by-create2kernel4fpu: " + str(task4kernel2fpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '38Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (39) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2fpu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 39A0F/70) set" + "; cplusfunction4fpu-set-by-create2kernel4fpu to: " + str(task4kernel2fpu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4fpu      = kb2kernel4fpu ['.cpp'] ['TAG']
            message2print = "{(Step 39A2/70) using" + "; tag2search4fpu-using-by-create2kernel4fpu: " + str(tag2search4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # function =
            
            attribute2search4fpu= kb2kernel4fpu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 39A4/70) using" + "; attribute2search4fpu-using-by-create2kernel4fpu: " + str(attribute2search4fpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4fpu in keys2code4fpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4fpu]
                    message2print = "{(Step 39A5/70) using" + "; key2code4fpu-using-by-create2kernel4fpu: " + str(key2code4fpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # fpu2dummy4xi5test.cpp
                       
                    keys2line4fpu = code2examine4fpu.keys()
                    # message2print = "{(Step 39A6/70) using" + "; keys2line4fpu-using-by-create2kernel4fpu: " + str(keys2line4fpu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4fpu in keys2line4fpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4fpu = task4kernel2fpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4fpu] [key2line4fpu]
                        # message2print = "{(Step 39A7/70) examining" + "; line2examine4fpu-examining-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # function = "nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4fpu,tag2search4fpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 39B1/70) examining" + "; line2function4fpu-examining-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # function = "OCLError" usage = "error code checking"*/
                            # function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 39B2/70) using" + "; attribute2search4fpu-using-by-create2kernel4fpu: " + str(attribute2search4fpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4fpu,attribute2search4fpu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 39C/70) skipped" + "; line2function4fpu-skipped-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 39E/70) accepted" + "; line2examine4fpu-accepted-by-create2kernel4fpu: " + str(line2examine4fpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "nbody_kern" usage = "kernel example 1"*/; 
                                # function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4fpu = line2examine4fpu[27:index2usage-2]  
                                task4kernel2fpu ['FUNCTION'] ['.cpp'] [key2kernelfunction4fpu] =  {}                                       

                                message2print = "{(Step 39F/70) used" + "; key2kernelfunction4fpu-used-by-create2kernel4fpu: " + str(key2kernelfunction4fpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '39F-'
                                    
            except: 
                message2print = "{(Step 37Z1/70) yielded" + "; program-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + '37Z1-'
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; function-fpu2kernel4xi-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-'                               
                
    if 'FUNCTION' in keys2task:    
        message2print = "{(Step 38A/70) trying" + "; function-trying-by-create2kernel4fpu: " + str(task4kernel2fpu['FUNCTION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'.py': {'fpu2sampler4xi5test': {}}, 
        # '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}    
        try:            
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            fpu2kernel4xi['FUNCTION']  = task4kernel2fpu['FUNCTION']   
     
            message2print = "{(Step 38B/70) created" + "; function-created-by-create2kernel4fpu: " + str(fpu2kernel4xi['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'.py': {'fpu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}} 
            
            code2ack  = code2ack + '38B-'
        except: 
            message2print = "{(Step 38Z1/70) yielded" + "; function-yielded-by-create2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '38Z1-'            
                                       
                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)     
    # -----------------------------------------------------------------------------------------
    fpu2kernel4xi ['ACK2RETURN']  = code2ack
    fpu2kernel4xi ['NACK2RETURN'] = code2nack 
     
    keys2kernel4fpu = fpu2kernel4xi.keys()
    message2print = "{(Step 70A/70) returning" + "; keys2kernel4fpu-returning-by-create2kernel4fpu: " + str(keys2kernel4fpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 (no parameters given by caller): 
    # ['DIRECTORY4CL',
    #  'DIRECTORY4PY',
    #  'DIRECTORY4C',
    #  'DIRECTORY4CPP',
    #  'DIRECTORY4PYC',    
    #  'DIRECTORY4BIN',    
    #  'CODE4PY',
    #  'CODE4PYC',
    #  'CODE4CPP',
    #  'CODE4BIN',
    #  'CODE4C',
    #  'CODE4CL',
    #  'COUNT4C',                
    #  'COUNT4CL',    
    #  'COUNT4CPP',
    #  'COUNT4PYC',
    #  'COUNT4PY',
    #  'COUNT4BIN',
    #  'SIZE4PY',    
    #  'SIZE4CPP', <-- OK: C and CL MISSING
    #  'SIZE4PYC',
    #  'SIZE4BIN',
                        
    #  'QUEUE',
    #  'PROGRAM',
    #  'CONTEXT',
    #  'PIPE',
    #  'FUNCTION2CALLBACK',
    #  'COMMANDQUEUE',
    #  'PLATFORM',
    #  'FUNCTION',
    #  'CODE2ERROR',
    #  'ACK2RETURN',
    #  'DATA2CALLBACK',
    #  'BUFFER',
    #  'COUNT2REFERENCE',
    #  'DEVICE',
    #  'LANGUAGE',
    #  'NACK2RETURN',
    #  'EVENT']



    
    #2 (function and program parameters given by user):
    # ['FUNCTION',
    #  'ACK2RETURN',
    #  'PROGRAM',
    #  'NACK2RETURN']

    
    keys2programkernel4fpu = fpu2kernel4xi['PROGRAM'].keys()
    message2print = "{(Step 70B/70) returning" + "; keys2programkernel4fpu-returning-by-create2kernel4fpu: " + str(keys2programkernel4fpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 and 2:
    # ['CODE2ERROR', 'LANGUAGE4SOURCE', 'COUNT4SOURCE' ...
    
    try:
        message2print = "{(Step 70C1/70) returning" + "; count2py4fpu-returning-by-create2kernel4fpu: " + str(fpu2kernel4xi ['COUNT4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C2/70) returning" + "; count2cpp4fpu-returning-by-create2kernel4fpu: " + str(fpu2kernel4xi ['COUNT4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C3/70) returning" + "; count2c4fpu-returning-by-create2kernel4fpu: " + str(fpu2kernel4xi ['COUNT4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
    
    try:
        message2print = "{(Step 70C4/70) returning" + "; count2cl4fpu-returning-by-create2kernel4fpu: " + str(fpu2kernel4xi ['COUNT4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S1/70) returning" + "; size2py4fpu-returning-by-create2kernel4fpu: " + str(fpu2kernel4xi['SIZE4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # pu2sampler4xi5test.py': 1337
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S2/70) returning" + "; size2cpp4fpu-returning-by-create2kernel4fpu: " + str(fpu2kernel4xi['SIZE4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # fpu2dummy4xi5test.cpp': 331
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S3/70) returning" + "; size2c4fpu-returning-by-create2kernel4fpu: " + str(fpu2kernel4xi['SIZE4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S4/70) returning" + "; size2cl4fpu-returning-by-create2kernel4fpu: " + str(fpu2kernel4xi['SIZE4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    


    message2print = "{(Step 70T/70) returning" + "; function2kernel4fpu-returning-by-create2kernel4fpu: " + str(fpu2kernel4xi['FUNCTION']) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # {'.py':  {'fpu2sampler4xi5test': {}},
    #  '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}
    # }  
        
    
                         
    return fpu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "add2kernel4fpu" usage = "
#     
#   print('(Step 3A2/700) OF FPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4add2kernel = {}
#       task4add2kernel ['CODE4KERNEL'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4fpu + 'fpu2dummy4xi.py'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4fpu + 'fpu2dummy4xi.py'] [1] = '... profile = "11" />'
#       task4add2kernel ['SIZE4KERNEL'] = {}
#       task4add2kernel ['SIZE4KERNEL'] [folder2lib4fpu + 'fpu2dummy4xi.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4fpu + 'fpu2dummy4xi.py'])
#       
#       response4add2kernel = add2kernel4fpu(task4add2kernel)
#       print('(Step 3A3/700) OF FPU2KERNEL4XI5TEST - ADDED KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z2/700) OF FPU2KERNEL4XI5TEST *** FAILED TO PRINT response4add2kernel: ', response4add2kernel)
#          
#">

# -------------------------------------------------------------------------------------------------   
def add2kernel4fpu(task4kernel2fpu):

    '''
    adds to kernel for FPU
    '''
    global fpu2kernel4xi                                                                                            # Kernel of FPU    
    global folder2lib4fpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "add2kernel4fpu" 
    method2print = "add2kernel4fpu"

    message2print = "{(Step 10A/70) started" + "; add2kernel4fpu-started: " + str(add2kernel4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2fpu-to-add2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
    code2ack  = ' '
    code2nack = ' ' 
    try:
        keys2kernel4task = task4kernel2fpu ['CODE4KERNEL'].keys()
        message2print = "{(Step 10C/70) using" + "; keys2kernel4task-using-by-add2kernel4fpu: " + str(keys2kernel4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #         
    except: 
        message2print = "{(Step 10Z1/70) failed" + "; keys2kernel4task-failed-by-add2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    try:
        keys2exist4task =  fpu2kernel4xi ['CODE4KERNEL'].keys() 
        message2print = "{(Step 10D/70) using" + "; keys2exist4task-using-by-add2kernel4fpu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    except:
        try:
            response2createwb4fpu = create2kernelsinkernel4fpu()
            keys2createwb4fpu = response2createwb4fpu.keys()
            for key2createwb4fpu in keys2createwb4fpu:
                if key2createwb4fpu == 'CODE4KERNEL':
                    message2print = "{(Step 10E/70) created" + "; key2createwb4fpu-created-by-add2kernel4fpu: " + str(key2createwb4fpu) + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)
                    # 
            
            keys2exist4task =  fpu2kernel4xi ['CODE4KERNEL'].keys() 
            message2print = "{(Step 10F/70) using" + "; keys2exist4task-using-by-add2kernel4fpu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        
        except: 
            message2print = "{(Step 10Z2/70) failed" + "; fpu2kernel4xi-failed-by-add2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - EXPECTED - SEVERAL KERNEL CODE CAN BE ADDED INTO ONE PROGRAM OBJECT                              
        # ---------------------------------------------------------------------------------------------             
        for key2kernel4task in keys2kernel4task:
            try:
                message2print = "{(Step 33A/70) using" + "; key2kernel4task-using-by-add2kernel4fpu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                            
                if key2kernel4task in keys2exist4task:
                    message2print = "{(Step 33Z0/70) yielded" + "; key2kernel4task-yielded-by-add2kernel4fpu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # folder2lib4fpu +  
                     
                    code2nack  = code2nack + '33Z0-'
                else: 
                    try:
                        fpu2kernel4xi ['CODE4KERNEL'] [key2kernel4task] = task4kernel2fpu ['CODE4KERNEL'] [key2kernel4task]
                    except:
                        message2print = "{(Step 33Z1/70) failed" + "; task4kernel2fpu-failed-by-add2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z1-' 
                    try:             
                        message2print = "{(Step 33B/70) added" + "; key2kernel4task-added-by-add2kernel4fpu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        #folder2lib4fpu +  
                    except:
                        message2print = "{(Step 33Z2/70) failed" + "; task4kernel2fpu-failed-by-add2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z2-' 
                    try:             
                        message2print = "{(Step 33C/70) added" + "; code-added-by-add2kernel4fpu to: " + str(fpu2kernel4xi ['CODE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z3/70) failed" + "; task4kernel2fpu-failed-by-add2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        code2nack  = code2nack + '33Z3-'                 
                    try:
                        fpu2kernel4xi ['COUNT4KERNEL'] = fpu2kernel4xi ['COUNT4KERNEL'] + 1
                        message2print = "{(Step 33D/70) added" + "; count4kernel-added-by-add2kernel4fpu to: " + str(fpu2kernel4xi ['COUNT4KERNEL'])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z4/70) failed" + "; task4kernel2fpu-failed-by-add2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z4-' 
                    try:                            
                        fpu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task]  = task4kernel2fpu['SIZE4KERNEL'] [key2kernel4task]  
                        message2print = "{(Step 33E/70) set" + "; size4kernel-set-by-add2kernel4fpu to: " + str(fpu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                        code2ack  = code2ack + '33D-'
                    except:
                        message2print = "{(Step 33Z5/70) failed" + "; task4kernel2fpu-failed-by-add2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z5-'    
            except:
                message2print = "{(Step 33Z6/70) failed" + "; task4kernel2fpu-failed-by-add2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                code2nack  = code2nack + '33Z6-'                     
    except: 
        message2print = "{(Step 33Z7/70) yielded" + "; kernel-yielded-by-add2kernel4fpu: " + str(fpu2kernel4xi ['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '33Z7-'       
          
                                                                                                                   
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    fpu2kernel4xi ['ACK2RETURN']  = code2ack
    fpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernelkernels = fpu2kernel4xi ['CODE4KERNEL'].keys()
    for key2kernelkernel in sorted(keys2kernelkernels):
        message2print = "{(Step 70A/70) got" + "; key2kernelkernel-got-by-add2kernel4fpu: " + str(key2kernelkernel) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        #folder2lib4fpu +  


    keys2kernel4fpu = fpu2kernel4xi.keys()
    for key2kernel4fpu in keys2kernel4fpu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4fpu-returning-by-add2kernel4fpu: " + str(key2kernel4fpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return fpu2kernel4xi
            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2nativekernel4fpu" usage = "
#     
#   print('(Step 2A2/700) OF FPU2KERNEL4XI5TEST - TRYING TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())           
#   try:
#       response4execute = execute2nativekernel4fpu()
#   except:
#       print('(Step 2Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION *** ', time4xi())                                                                      
#          
#">

# -------------------------------------------------------------------------------------------------   
def execute2nativekernel4fpu(task4program2fpu=None):

    '''
    executes native kernel of FPU
    '''
    global fpu2kernel4xi                                                                                            # Kernel of FPU    
    global import2use4fpu                                                                                           # Imports of FPU
    global target2function4fpu                                                                                      # Target function of Process4Xi
    global folder2lib4fpu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2nativekernel4fpu" 
    method2print = "execute2nativekernel4fpu"

    message2print = "{(Step 1A/70) started" + "; execute2nativekernel4fpu-started: " + str(execute2nativekernel4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4program2fpu-to-execute2nativekernel4fpu: " + str(task4program2fpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    kernel2program4fpu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
    message2print = "{(Step 1C/70) initialized" + "; kernel2program4fpu-initialized-by-execute2nativekernel4fpu to: " + str(kernel2program4fpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #                
    try:             
        if task4program2fpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4program2fpu-yielded-by-execute2nativekernel4fpu: " + str(task4program2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - EXECUTE NATIVE KERNELS INSIDE PROGRAM OBJECT FOR FPU ! 
    # ---------------------------------------------------------------------------------------------    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                            
        # ---------------------------------------------------------------------------------------------             
        keys2kernel4fpu = fpu2kernel4xi['CODE4KERNEL'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2kernel4fpu-using-by-execute2nativekernel4fpu: " + str(keys2kernel4fpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        unit4processing = "fpu"
        
        for key2kernel4fpu in keys2kernel4fpu:
            index2search=str.find(key2kernel4fpu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2execute = key2kernel4fpu[index2search:]                                                          # fpu2sampler4xi5test.py
                index2search=str.find(target2execute,".py")
                if index2search == -1:
                    pass
                else:
                    target2execute4fpu = target2execute[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2execute4fpu-set-by-execute2nativekernel4fpu to: " + str(target2execute4fpu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # 

                    p2kernel4fpu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4FPU 
                        # ---------------------------------------------------------------------------------------------    
             
                        try:
                            import2use4fpu.get(target2execute4fpu, handle2error4fpu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2execute4fpu-imported-by-execute2nativekernel4fpu: " + str(target2execute4fpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4fpu-failed-by-execute2nativekernel4fpu: " + str(import2use4fpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2execute4fpu-used-by-execute2nativekernel4fpu: " + str(target2execute4fpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4FPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2fpu = Process4Xi(target=target2function4fpu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2fpu-created-by-execute2nativekernel4fpu: " + str(p2fpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-1, initial)>
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2fpu.start()
                            message2print = "{(Step 34A/70) started" + "; p2fpu-started-by-execute2nativekernel4fpu: " + str(p2fpu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-1
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4fpu = p2fpu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-execute2nativekernel4fpu: " + str(status2process4fpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2fpu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2fpu-run-by-execute2nativekernel4fpu: " + str(p2fpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-execute2nativekernel4fpu: " + str(p2fpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-execute2nativekernel4fpu: " + str(p2fpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-execute2nativekernel4fpu: " + str(p2fpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2kernel4fpu-failed-by-execute2nativekernel4fpu: " + str(p2kernel4fpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    
            # ---------------------------------------------------------------------------------------------
            # SAVE SOURCE WITHOUT END OF LINES
            # ---------------------------------------------------------------------------------------------        
            keys2lines = fpu2kernel4xi['CODE4KERNEL'][key2kernel4fpu].keys()     
            kernel2program4fpu[key2kernel4fpu] = ""
            for key2line in keys2lines:
                code2add4fpu = fpu2kernel4xi ['CODE4KERNEL'] [key2kernel4fpu] [key2line]
                kernel2program4fpu[key2kernel4fpu] = kernel2program4fpu[key2kernel4fpu] + code2add4fpu.replace("\n","")
        
            message2print = "{(Step 34A/70) saved" + "; lenght-kernel4fpu-saved-by-execute2nativekernel4fpu to: " + str(len(kernel2program4fpu[key2kernel4fpu]))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #     
                
 
        message2print = "{(Step 38A/70) set" + "; lenght-kernel2program4fpu-set-by-execute2nativekernel4fpu to: " + str(len(kernel2program4fpu))  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; kernel-yielded-by-execute2nativekernel4fpu: " + str(fpu2kernel4xi['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    fpu2kernel4xi ['ACK2RETURN']  = code2ack
    fpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernel4fpu = kernel2program4fpu.keys()
    for key2kernel4fpu in keys2kernel4fpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4fpu-returning-by-execute2nativekernel4fpu: " + str(key2kernel4fpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        # 
    
    return kernel2program4fpu
            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "delete2kernel4fpu" usage = "
#     
#   print('(Step 3A3/700) OF FPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4delete2kernel = {}
#       task4delete2kernel ['CODE4KERNEL'] = {}
#       task4delete2kernel ['CODE4KERNEL'] [folder2lib4fpu + 'fpu2program4xi.py'] = 'Yes'
#       task4delete2kernel ['SIZE4KERNEL'] = {}
#       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4fpu + 'fpu2program4xi.py'] = 'Yes'
#       
#       response4delete2kernel = delete2kernel4fpu(task4delete2kernel) 
#       print('(Step 3A3/700) OF FPU2KERNEL4XI5TEST - DELETED KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF FPU2KERNEL4XI5TEST *** FAILED TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION *** ', time4xi()) 
#          
#">

# -------------------------------------------------------------------------------------------------   
def delete2kernel4fpu(task4kernel2fpu):

    '''
    deletes kernel for FPU
    '''
    global fpu2kernel4xi                                                                                     
    global folder2lib4fpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "delete2kernel4fpu" 
    method2print = "delete2kernel4fpu"

    message2print = "{(Step 10A/70) started" + "; delete2kernel4fpu-started: " + str(delete2kernel4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function delete2kernel4fpu at 0x000000000405CEC8>
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2fpu-to-delete2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 


    code2ack  = ' '
    code2nack = ' '    
    #
    ack4key2kernelkernel = False
    try:
        # ---------------------------------------------------------------------------------------------
        # TASK MUST HAVE BEEN GIVEN BY USER - CONTAINS KERNEL KEYS    
        # ---------------------------------------------------------------------------------------------
        keys2delete4kernel = task4kernel2fpu ['CODE4KERNEL'].keys()        
        message2print = "{(Step 19A/70) using" + "; keys2delete4kernel-using-by-delete2kernel4fpu: " + str(sorted(keys2delete4kernel))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # ---------------------------------------------------------------------------------------------
        # (Step 20A/70) - DELETE KERNEL INSIDE PROGRAM OBJECT FOR FPU ! 
        # ---------------------------------------------------------------------------------------------    
        message2print = "{(Step 20A0/70) try" + "; key-try-by-delete2kernel4fpu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      

        for key2delete4kernel in keys2delete4kernel:
            try:            
                del fpu2kernel4xi ['CODE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20C/70) deleted" + "; code4kernel-deleted-by-delete2kernel4fpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20C-' 
                
                del fpu2kernel4xi ['SIZE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20D/70) deleted" + "; size4kernel-deleted-by-delete2kernel4fpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20D-' 
                
                fpu2kernel4xi ['COUNT4KERNEL'] = fpu2kernel4xi ['COUNT4KERNEL'] - 1
                message2print = "{(Step 20E/70) upgraded" + "; count4kernel-upgraded-by-delete2kernel4fpu: " + str(fpu2kernel4xi ['COUNT4KERNEL'] ) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                #                                
                
            except:
                message2print = "{(Step 20Z1/70) yielded" + "; key2delete4kernel-yielded-by-delete2kernel4fpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                
                code2nack  = code2nack + '20Z1-' 
    except: 
        message2print = "{(Step 20Z0/70) failed" + "; task4kernel2fpu-fpu2kernel4xi-failed-by-delete2kernel4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '20Z0-'    
                                                                                            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    fpu2kernel4xi ['ACK2RETURN']  = code2ack
    fpu2kernel4xi ['NACK2RETURN'] = code2nack  
    try:
        keys2kernelkernels = fpu2kernel4xi ['CODE4KERNEL'] .keys()
        for key2kernelkernels in keys2kernelkernels:
            message2print = "{(Step 70A/70) got" + "; key2kernelkernels-got-by-delete2kernel4fpu: " + str(key2kernelkernels) + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                              
            #  
    except:
        pass 
               
     
    keys2kernel4fpu = fpu2kernel4xi.keys()
    for key2kernel4fpu in keys2kernel4fpu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4fpu-returning-by-delete2kernel4fpu: " + str(key2kernel4fpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 


    return fpu2kernel4xi
            
#</function4xi> 
 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernelsinprogram4fpu" usage = "
#     
#   print('(Step 3A1/700) OF FPU2KERNEL4XI5TEST - TRYING TO CREATE KERNELS IN PROGRAM FOR FPU ', time4xi())          
#   try:
#       response4create2kernelsinprogram = create2kernelsinprogram4fpu()
#       print('(Step 3A2/700) OF FPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRAM FOR FPU ', time4xi())
#   except:
#       print('(Step 3Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNELS IN PROGRAM FOR FPU *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def create2kernelsinprogram4fpu(task4kernel2fpu=None):

    '''
    creates kernels in program for FPU
    '''
    global fpu2kernel4xi                                                                                            # Kernel of FPU    
    global folder2lib4fpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernelsinprogram4fpu" 
    method2print = "create2kernelsinprogram4fpu"

    message2print = "{(Step 1A/70) started" + "; create2kernelsinprogram4fpu-started: " + str(create2kernelsinprogram4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2fpu-to-create2kernelsinprogram4fpu: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    

    
    keys2kernel4fpu = fpu2kernel4xi.keys()
    for key2kernel4fpu in keys2kernel4fpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4fpu-returning-by-create2kernelsinprogram4fpu: " + str(key2kernel4fpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return fpu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fetch2kernel4fpu" usage = "
#   fetch2kernel4fpu(file2walk)
#"> 
# -------------------------------------------------------------------------------------------------
def fetch2kernel4fpu(program2explore4fpu):
    global fetch2code4fpu                                                                                           # dictionary to receive files 
        
    global kb2fetch4fpu                                                                                             # knowledgebase for fetching
    global profile2fetch                                                                                            # profiles
    global keys2profile4fpu                                                                                         # file extensions 
    
    global folder2lib4fpu  

    class2print  = "fetch2kernel4fpu"
    method2print = "fetch2kernel4fpu" 
     
    message2print = "{(Step 1A/33) passed" + "; program2explore4fpu-passed-to-fetch2kernel4fpu: " + str(program2explore4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # folder2lib4fpu + fpu2buffer4xi.py          ... fpu2sampler4xi5test.py ... fpu2dummy4xi5test.cpp ...           # Python and C++ programs
    # __pycache__\fpu2buffer4xi.cpython-33.pyc   ... fpu2sampler4xi5test.cpython-33.pyc ...                         # Cache of Python binaries
    # //bin\fpu2dummy4xi5test.exe                                                                                   # Built C++ exe files
                  
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program4fpu=os.path.splitext(program2explore4fpu)                                                          # fpu2sampler4xi5test + py

    key2extension4fpu = name2program4fpu[1]                                                                         # py,pyc,cpp,exe 
    message2print = "{(Step 1B/33) set" + "; key2extension4fpu-set-by-fetch2kernel4fpu to: " + str(key2extension4fpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # .py; .pyc
    message2print = "{(Step 1C/33) using" + "; profile2fetch-using-by-fetch2kernel4fpu: " + str(profile2fetch)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # {'.pyc': 'NACK', '.py': 'ACK', '.cpp': 'ACK', '.exe': 'NACK'}  
        
    if profile2fetch [key2extension4fpu] == 'ACK':                                                                  # profile2fetch ['py']  = 'ACK'       
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF FETCH2SCOPE4XI - EXTENSION IN PROFILE 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore4fpu-analyzing-by-fetch2kernel4fpu: " + str(program2explore4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # folder2lib4fpu +  fpu2buffer4xi.py ; fpu2sampler4xi5test.py ...  ... __pycache__\fpu2sampler4xi5test.cpython-33.pyc
        # fpu2dummy4xi5test.cpp
             
        path2input4fpu = program2explore4fpu
        message2print = "{(Step 1B/33) set" + "; path2input4fpu-set-by-fetch2kernel4fpu to: " + str(path2input4fpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # folder2lib4fpu +  fpu2buffer4xi.py ; __pycache__\fpu2sampler4xi5test.cpython-33.pyc; fpu2dummy4xi5test.cpp

        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF FETCH2SCOPE4XI - CHECKING WHETHER PROGRAM MUST BE FETCHED 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A1/33) analyzing" + "; path2input4fpu-analyzing-by-fetch2kernel4fpu: " + str(path2input4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #folder2lib4fpu +  fpu2buffer4xi.py ; fpu2dummy4xi5test.cpp 
            
        keys2fetch4fpu = kb2fetch4fpu.keys()
        message2print = "{(Step 2A2/33) using" + "; keys2fetch4fpu-using-by-fetch2kernel4fpu: " + str(keys2fetch4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #        
        ack2match4file = False
        for key2fecth4fpu in keys2fetch4fpu:                                                                        # 1,2 ...
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------
            index2search=str.find(path2input4fpu,kb2fetch4fpu[key2fecth4fpu])                                       
            if index2search == -1:                                         
                # -----------------------------------------------------------------------------------------
                # VALID FILE TYPE BUT NOT SELECTED TO BE FETCHED - OK ONE MAY ALSO PASS HERE!
                # -----------------------------------------------------------------------------------------               
                message2print = "{(Step 2C1/33) skipped" + "; path2input4fpu-skipped-by-fetch2kernel4fpu: " + str(path2input4fpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                # folder2lib4fpu +  fpu2buffer4xi.py 
                
            else:
                ack2match4file = True
                
                message2print = "{(Step 2D/33) decided" + "; program-to-read-decided-by-fetch2kernel4fpu: " + str(path2input4fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
                #folder2lib4fpu +  fpu2sampler4xi5test.py; __pycache__//fpu2sampler4xi.cpython-33.pyc; 
                #               +  fpu2dummy4xi5test.cpp

                # -----------------------------------------------------------------------------------------
                # (Step 3/33) OF FETCH2SCOPE4XI - OPEN INPUT FILE - READ MODE SET ACCORDING TO FILE TYPE
                # -----------------------------------------------------------------------------------------
                if ((key2extension4fpu == '.py') or (key2extension4fpu == '.cpp') or (key2extension4fpu == '.c') or (key2extension4fpu == '.cl')):
                    file2input4fpu = open(path2input4fpu,'r')
                    message2print = "{(Step 3A/33) opened" + "; file2input4fpu-opened-by-fetch2kernel4fpu: " + str(file2input4fpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # <_io.TextIOWrapper name=folder2lib4fpu + 'fpu2sampler4xi5test.py' mode='r' encoding='cp1252'> 
                     
                if ((key2extension4fpu == '.pyc') or (key2extension4fpu == '.exe')):
                    file2input4fpu = open(path2input4fpu,'rb')
                    message2print = "{(Step 3B/33) opened" + "; file2input4fpu-opened-by-fetch2kernel4fpu: " + str(file2input4fpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    #  __pycache__//fpu2sampler4xi.cpython-33.pyc               
                    
                # -----------------------------------------------------------------------------------------
                # (Step 4/33) OF FETCH2SCOPE4XI - OUTPUT 
                # -----------------------------------------------------------------------------------------
                key2save4fpu = path2input4fpu
                fetch2code4fpu[key2save4fpu] = {}                                                                   # fetch2code4fpu['fpu2sampler4xi5test.py'] = {}
                number2line4fpu = 0  
                message2print = "{(Step 3B/33) saving" + "; key2fecth4fpu-saving-by-fetch2kernel4fpu: " + str(key2fecth4fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
         
                while 1:
                    # -------------------------------------------------------------------------------------
                    # (Step 5/33) OF FETCH2SCOPE4XI - PROCESS FILE
                    # -------------------------------------------------------------------------------------             
                    line2process4fpu = file2input4fpu.readline()  
                    if not line2process4fpu:
                        # ---------------------------------------------------------------------------------
                        # (Step 30/33) OF FETCH2SCOPE4XI - ALL LINES READ, FINISH
                        # ---------------------------------------------------------------------------------             
                        break                                               
                    else:
                        # ---------------------------------------------------------------------------------
                        # (Step 7/33) OF FETCH2SCOPE4XI - SAVE LINE
                        # ---------------------------------------------------------------------------------
                        # message2print = "{(Step 7A/33) read" + "; line2process4fpu-read-by-fetch2kernel4fpu: " + str(line2process4fpu) + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print)              
                        # ... profile = "11" />
                        # ...
                        # # end of fpu2sampler4xi5test.py 
                        # #/> 
                        try:
                            number2line4fpu = number2line4fpu + 1
                            fetch2code4fpu[key2save4fpu][number2line4fpu] = line2process4fpu
                        except:
                            message2print = "{(Step 7Z1/33) failed" + "; key2fecth4fpu-failed-by-fetch2kernel4fpu: " + str(key2fecth4fpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z2/33) failed" + "; line2process4fpu-failed-by-fetch2kernel4fpu: " + str(line2process4fpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z3/33) failed" + "; number2line4fpu-failed-by-fetch2kernel4fpu: " + str(number2line4fpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                                                             
                # -----------------------------------------------------------------------------------------
                # (Step 31/33) OF FETCH2SCOPE4XI - CLOSE INPUT
                # -----------------------------------------------------------------------------------------            
                file2input4fpu.close()
                message2print = "{(Step 31A/33) closed" + "; file2input4fpu-closed-by-fetch2kernel4fpu: " + str(file2input4fpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                # <_io.TextIOWrapper name=folder2lib4fpu + 'fpu2sampler4xi5test.py' mode='r' encoding='cp1252'>     # Python source files
                # {folder2lib4fpu + 'fpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: '# -- 
                # fpu2dummy4xi5test.cpp                                                                             # C++ source files
                # __pycache__//fpu2sampler4xi.cpython-33.pyc                                                        # Cached binary files of Python
                # fpu2dummy4xi5test.exe                                                                             # C++ exe files
        
                message2print = "{(Step 31B1/33) saved" + "; fetch2code4fpu-saved-by-fetch2kernel4fpu: " + str(fetch2code4fpu[key2save4fpu] [1]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... profile = "11" />
                
                message2print = "{(Step 31B2/33) saved" + "; fetch2code4fpu-saved-by-fetch2kernel4fpu: " + str(fetch2code4fpu[key2save4fpu] [2]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # fpu2dummy4xi5test.cpp
                
                message2print = "{(Step 31B3/33) saved" + "; fetch2code4fpu-saved-by-fetch2kernel4fpu: " + str(fetch2code4fpu[key2save4fpu] [3]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... program = "fpu2sampler4xi5test.py">
                
                message2print = "{(Step 31B4/33) saved" + "; fetch2code4fpu-saved-by-fetch2kernel4fpu: " + str(fetch2code4fpu[key2save4fpu] [4]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ...  abstract = "tests fpu2sampler4xi.py"/>
                                                                 
                # ---------------------------------------------------------------------------------------------
                #
                # ---------------------------------------------------------------------------------------------                                          


    else:
        # -----------------------------------------------------------------------------------------
        # FILE TYPE - NOT IN PROFILE
        # -----------------------------------------------------------------------------------------       
        message2print = "{(Step 1F/33) skipped" + "; name2program4fpu-skipped-by-fetch2kernel4fpu: " + str(name2program4fpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # folder2lib4fpu + '__pycache__//fpu2buffer4xi.cpython-32', '.pyc')
        
        extension2skip = name2program4fpu[1]
        message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-fetch2kernel4fpu: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # pyc

        message2print = "{(Step 1H/33) returning" + "; fetch2kernel4fpu-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
 
    message2print = "{(Step 1H/33) returning" + "; fetch2kernel4fpu-returning: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)            
    #   
                                            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernel4fpu" usage = "
#
#   ... prepare task4set2kernelws ...    
#
#   response4set2kernel = {} 
#   print('(Step 17F/700) OF FPU2KERNEL4XI5TEST - TRYING TO SET KERNEL: ', set2kernel4fpu)   
#   # 
#   try:                               
#       response4set2kernel = set2kernel4fpu(task4set2kernelws)
#       print('(Step 17G/700) OF FPU2KERNEL4XI5TEST - SET KERNEL: ', response4set2kernel)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF FPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL: ', set2kernel4fpu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernel4fpu(task4kernelset2fpu=None):

    '''
    sets kernels for FPU
    '''
    global fpu2kernel4xi  
    global folder2lib4fpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernel4fpu"
    method2print = "set2kernel4fpu" 

    message2print = "{(Step 1A/33) started" + "; set2kernel4fpu-started: " + str(set2kernel4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernel4fpu at 0x0000000003837948> 
    
    keys2task = task4kernelset2fpu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernel4fpu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
        
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if fpu2kernel4xi is None:
            fpu2kernel4xi = create2kernel4fpu()                                                                              # INITIALIZE PROGRAM FOR FPU 
            message2print = "{(Step 1C/70) set" + "; fpu2kernel4xi-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4fpu-skipped-by-set2kernel4fpu: " + str(create2kernel4fpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            fpu2kernel4xi = create2kernel4fpu()
            message2print = "{(Step 1E/70) set" + "; fpu2kernel4xi-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            fpu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; fpu2kernel4xi-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['DATA2CALLBACK'] = task4kernelset2fpu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-fpu2kernel4xi-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelset2fpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-fpu2kernel4xi-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['PLATFORM'] = task4kernelset2fpu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-fpu2kernel4xi-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2fpu-try-by-set2kernel4fpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['CONTEXT'] = task4kernelset2fpu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-fpu2kernel4xi-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernel4fpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['DEVICE'] = task4kernelset2fpu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-fpu2kernel4xi-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['CODE2ERROR'] = task4kernelset2fpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-fpu2kernel4xi-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['QUEUE'] = task4kernelset2fpu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-fpu2kernel4xi-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['PIPE'] = task4kernelset2fpu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-fpu2kernel4xi-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernel4fpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['COMMANDQUEUE']  = task4kernelset2fpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernel4fpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        fpu2kernel4xi['BUFFER']  = task4kernelset2fpu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernel4fpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['EVENT']  = task4kernelset2fpu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'
                    
              
    message2print = "{(Step 31A/70) try" + "; count2py4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4PY                           
        # ---------------------------------------------------------------------------------------------             
        fpu2kernel4xi['COUNT4PY']  = task4kernelset2fpu['COUNT4PY']  
 
        message2print = "{(Step 31B/70) set" + "; count2py4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count2py4fpu-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  
                
    message2print = "{(Step 31C/70) try" + "; count2pyc4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31C)  - COUNT4PYC                           
        # ---------------------------------------------------------------------------------------------             
        fpu2kernel4xi['COUNT4PYC']  = task4kernelset2fpu['COUNT4PYC']  
 
        message2print = "{(Step 31D/70) set" + "; count2pyc4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31D-'
    except: 
        message2print = "{(Step 31Z2/70) yielded" + "; count2pyc4fpu-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z2-'  
                
    message2print = "{(Step 31E/70) try" + "; count2c4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31E)  - COUNT4C                           
        # ---------------------------------------------------------------------------------------------             
        fpu2kernel4xi['COUNT4C']  = task4kernelset2fpu['COUNT4C']  
 
        message2print = "{(Step 31F/70) set" + "; count2c4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31F-'
    except: 
        message2print = "{(Step 31Z3/70) yielded" + "; count2c4fpu-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z3-'                  
                
    message2print = "{(Step 31G/70) try" + "; count2bin4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31G)  - COUNT4BIN                           
        # ---------------------------------------------------------------------------------------------             
        fpu2kernel4xi['COUNT4BIN']  = task4kernelset2fpu['COUNT4BIN']  
 
        message2print = "{(Step 31H/70) set" + "; count2bin4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31H-'
    except: 
        message2print = "{(Step 31Z4/70) yielded" + "; count2bin4fpu-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z4-'  
        
    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernel4fpu: " + str(task4kernelset2fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 
    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (32B) DIRECTORY4PY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        fpu2kernel4xi['DIRECTORY4PY']  = task4kernelset2fpu['DIRECTORY4PY'] 
        
        message2print = "{(Step 32B/70) set" + "; directory2py4fpu-set-by-set2kernelwithdirectory2py4fpu4fpu to: " + str(fpu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory2py4fpu-yielded-by-set2kernelwithdirectory2py4fpu4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32C) DIRECTORY4PYC - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        fpu2kernel4xi['DIRECTORY4PYC']  = task4kernelset2fpu['DIRECTORY4PYC'] 
        
        message2print = "{(Step 32C/70) set" + "; directory2pyc4fpu-set-by-set2kernelwithdirectory2pyc4fpu4fpu to: " + str(fpu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32C-'
    except: 
        message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4fpu-yielded-by-set2kernelwithdirectory2pyc4fpu4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z2-'

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32D) DIRECTORY4C - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        fpu2kernel4xi['DIRECTORY4CPP']  = task4kernelset2fpu['DIRECTORY4CPP'] 
        
        message2print = "{(Step 32D/70) set" + "; directory2c4fpu-set-by-set2kernelwithdirectory2c4fpu4fpu to: " + str(fpu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32D-'
    except: 
        message2print = "{(Step 32Z3/70) yielded" + "; directory2c4fpu-yielded-by-set2kernelwithdirectory2c4fpu4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z3-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32E) DIRECTORY4BIN - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        fpu2kernel4xi['DIRECTORY4BIN']  = task4kernelset2fpu['DIRECTORY4BIN'] 
        
        message2print = "{(Step 32E/70) set" + "; directory2bin4fpu-set-by-set2kernelwithdirectory2bin4fpu4fpu to: " + str(fpu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32E-'
    except: 
        message2print = "{(Step 32Z4/70) yielded" + "; directory2bin4fpu-yielded-by-set2kernelwithdirectory2bin4fpu4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z34-'         
                         
    message2print = "{(Step 33A/70) try" + "; code2py4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33B) CODE4PY - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['CODE4PY']  = task4kernelset2fpu['CODE4PY']  
 
        message2print = "{(Step 33B/70) set" + "; code2py4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4fpu + 'fpu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernel = "fpu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code2py4fpu-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2py4fpu2nack  = code2py4fpu2nack + '33Z1-'        
                         
    message2print = "{(Step 33C/70) try" + "; code2c4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33C) CODE4C - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['CODE4CPP']  = task4kernelset2fpu['CODE4CPP']  
 
        message2print = "{(Step 33D/70) set" + "; code2c4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['CODE4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4fpu + 
 
        code2c4fpu2ack  = code2c4fpu2ack + '33D-'
    except: 
        message2print = "{(Step 33Z2/70) yielded" + "; code2c4fpu-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2c4fpu2nack  = code2c4fpu2nack + '33Z2-'                     
                         
    message2print = "{(Step 33D/70) try" + "; code2pyc4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4PYC - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['CODE4PYC']  = task4kernelset2fpu['CODE4PYC']  
 
        message2print = "{(Step 33E/70) set" + "; code2pyc4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4fpu + 
 
        code2pyc4fpu2ack  = code2pyc4fpu2ack + '33E-'
    except: 
        message2print = "{(Step 33Z3/70) yielded" + "; code2pyc4fpu-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2pyc4fpu2nack  = code2pyc4fpu2nack + '33Z3-'        
                         
    message2print = "{(Step 33F/70) try" + "; code2bin4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4BIN - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['CODE4BIN']  = task4kernelset2fpu['CODE4BIN']  
 
        message2print = "{(Step 33G/70) set" + "; code2bin4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4fpu + 
 
        code2bin4fpu2ack  = code2bin4fpu2ack + '33G-'
    except: 
        message2print = "{(Step 33Z4/70) yielded" + "; code2bin4fpu-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2bin4fpu2nack  = code2bin4fpu2nack + '33Z4-'                
                
    message2print = "{(Step 34A/70) try" + "; size2py4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34B) SIZE4PY - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['SIZE4PY']  = task4kernelset2fpu['SIZE4PY']  
 
        message2print = "{(Step 34B/70) set" + "; size2py4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size2py4fpu-yielded-by-set2kernel4fpu: " + str(task4kernelset2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 34C/70) try" + "; size2c4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34C) SIZE4C - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['SIZE4C']  = task4kernelset2fpu['SIZE4C']  
 
        message2print = "{(Step 34D/70) set" + "; size2c4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34D-'
    except: 
        message2print = "{(Step 34Z2/70) yielded" + "; size2c4fpu-yielded-by-set2kernel4fpu: " + str(task4kernelset2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z2-'
                
    message2print = "{(Step 34E/70) try" + "; size2pyc4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34E) SIZE4PYC - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['SIZE4PYC']  = task4kernelset2fpu['SIZE4PYC']  
 
        message2print = "{(Step 34F/70) set" + "; size2pyc4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34F-'
    except: 
        message2print = "{(Step 34Z3/70) yielded" + "; size2pyc4fpu-yielded-by-set2kernel4fpu: " + str(task4kernelset2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z3-'          
                
    message2print = "{(Step 34G/70) try" + "; size2bin4fpu-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34G) SIZE4BIN - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['SIZE4BIN']  = task4kernelset2fpu['SIZE4BIN']  
 
        message2print = "{(Step 34H/70) set" + "; size2bin4fpu-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34H-'
    except: 
        message2print = "{(Step 34Z4/70) yielded" + "; size2bin4fpu-yielded-by-set2kernel4fpu: " + str(task4kernelset2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z4-'  
        
    
                                  
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE (DICTIONARY) - REQUIRED                     
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['LANGUAGE']  = task4kernelset2fpu['LANGUAGE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernel4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['COUNT2REFERENCE']  = task4kernelset2fpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernel4fpu to: " + str(fpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    fpu2kernel4xi ['ACK2RETURN']  = code2ack
    fpu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernel4fpu = fpu2kernel4xi.keys()
    for key2kernel4fpu in keys2kernel4fpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4fpu-returning-by-set2kernel4fpu: " + str(key2kernel4fpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return fpu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelarg4fpu" usage = "
#
#   ... prepare task4set2kernelargws ...    
#
#   response4set2kernelarg = {} 
#   print('(Step 17F/700) OF FPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS : ', set2kernelarg4fpu)   
#   # <function set2kernelarg4fpu at 0x0000000003837948>
#   try:                               
#       response4set2kernel = set2kernelarg4fpu(task4set2kernelargws)
#       print('(Step 17G/700) OF FPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS: ', set2kernelarg4fpu)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF FPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS: ', set2kernelarg4fpu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernelarg4fpu(task4kernelargset2fpu=None):

    '''
    sets kernel arguments for FPU
    '''
    global fpu2kernel4xi  
    global folder2lib4fpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernelarg4fpu"
    method2print = "set2kernelarg4fpu" 

    message2print = "{(Step 1A/33) started" + "; set2kernelarg4fpu-started: " + str(set2kernelarg4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernelarg4fpu at 0x0000000003837948> 
    
    keys2task = task4kernelargset2fpu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernelarg4fpu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
          
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if fpu2kernel4xi is None:
            fpu2kernel4xi = create2kernel4fpu()                                                                              # INITIALIZE PROGRAM FOR FPU 
            message2print = "{(Step 1C/70) set" + "; fpu2kernel4xi-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4fpu-skipped-by-set2kernelarg4fpu: " + str(create2kernel4fpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            fpu2kernel4xi = create2kernel4fpu()
            message2print = "{(Step 1E/70) set" + "; fpu2kernel4xi-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            fpu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; fpu2kernel4xi-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernelarg4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['DATA2CALLBACK'] = task4kernelargset2fpu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-fpu2kernel4xi-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernelarg4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelargset2fpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-fpu2kernel4xi-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernelarg4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['PLATFORM'] = task4kernelargset2fpu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-fpu2kernel4xi-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2fpu-try-by-set2kernelarg4fpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['CONTEXT'] = task4kernelargset2fpu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-fpu2kernel4xi-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernelarg4fpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['DEVICE'] = task4kernelargset2fpu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-fpu2kernel4xi-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernelarg4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['CODE2ERROR'] = task4kernelargset2fpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-fpu2kernel4xi-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernelarg4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['QUEUE'] = task4kernelargset2fpu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-fpu2kernel4xi-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernelarg4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['PIPE'] = task4kernelargset2fpu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-fpu2kernel4xi-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernelarg4fpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['COMMANDQUEUE']  = task4kernelargset2fpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernelarg4fpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        fpu2kernel4xi['BUFFER']  = task4kernelargset2fpu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernelarg4fpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['EVENT']  = task4kernelargset2fpu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'            
                
    message2print = "{(Step 31A/70) try" + "; count4source-try-by-set2kernelarg4fpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4SOURCE                           
        # ---------------------------------------------------------------------------------------------             
        fpu2kernel4xi['COUNT4SOURCE']  = task4kernelargset2fpu['COUNT4SOURCE']  
 
        message2print = "{(Step 31B/70) set" + "; count4source-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['COUNT4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count4source-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  

    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernelarg4fpu: " + str(task4kernelargset2fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'CODE2ERROR': 0 ... 'DIRECTORY4SOURCE': '...//a' ... 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32) DIRECTORY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        fpu2kernel4xi['DIRECTORY4SOURCE']  = task4kernelargset2fpu['DIRECTORY4SOURCE'] 
        
        message2print = "{(Step 32B/70) set" + "; directory-set-by-set2kernelargwithdirectory4fpu to: " + str(fpu2kernel4xi['DIRECTORY4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # OK
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory-yielded-by-set2kernelargwithdirectory4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 
        
    message2print = "{(Step 33A/70) try" + "; code-try-by-set2kernelarg4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['CODE4SOURCE']  = task4kernelargset2fpu['CODE4SOURCE']  
 
        message2print = "{(Step 33B/70) set" + "; code-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['CODE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4fpu + 'fpu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernelarg = "fpu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '33Z1-'             
        
    message2print = "{(Step 34A/70) try" + "; size-try-by-set2kernelarg4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34) SIZE - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['SIZE4SOURCE']  = task4kernelargset2fpu['SIZE4SOURCE']  
 
        message2print = "{(Step 34B/70) set" + "; size-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['SIZE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size-yielded-by-set2kernelarg4fpu: " + str(task4kernelargset2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernelarg4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['LANGUAGE4SOURCE']  = task4kernelargset2fpu['LANGUAGE4SOURCE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['LANGUAGE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernelarg4fpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        fpu2kernel4xi['COUNT2REFERENCE']  = task4kernelargset2fpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernelarg4fpu to: " + str(fpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernelarg4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    fpu2kernel4xi ['ACK2RETURN']  = code2ack
    fpu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernelarg4fpu = fpu2kernel4xi.keys()
    for key2kernelarg4fpu in keys2kernelarg4fpu:
        message2print = "{(Step 70/70) returning" + "; key2kernelarg4fpu-returning-by-set2kernelarg4fpu: " + str(key2kernelarg4fpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return fpu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2kernel4fpu" usage = "
#
#   task4release2kernel  = {} 
#   task4release2kernel  ['COUNT2REFERENCE'] = 1 
#   response4release2kernel = {}
#   
#   print('(Step 18A/700) OF FPU2KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF FPU DEVICE ', time4xi())    
#   try:                               
#       response4release2kernel = release2kernel4fpu(task4release2kernel)
#       print('(Step 18B/700) OF FPU2KERNEL4XI5TEST - RELEASED KERNEL OF FPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 18Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF FPU DEVICE ', time4xi())                                                                                                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def release2kernel4fpu(task4release2fpu=None):

    '''
    releases kernel for FPU
    '''
    global fpu2kernel4xi  
    global folder2lib4fpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2kernel4fpu"
    method2print = "release2kernel4fpu" 

    message2print = "{(Step 1A/33) started" + "; release2kernel4fpu-started: " + str(release2kernel4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4release2fpu-to-release2kernel4fpu: " + str(task4release2fpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    

    code2ack  = ' '
    code2nack = ' '

    try:
        if fpu2kernel4xi is None:
            fpu2kernel4xi = create2kernel4fpu()                                                                       # INITIALIZE KERNEL                 
    except:
        try:
            fpu2kernel4xi = create2kernel4fpu()
        except:
            fpu2kernel4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; fpu2kernel4xi-yielded-by-release2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2kernel4fpu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2fpu is None:
        task4release2fpu = {}
        task4release2fpu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        fpu2kernel4xi['COUNT2REFERENCE'] = fpu2kernel4xi['COUNT2REFERENCE'] - task4release2fpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2kernel4fpu: " + str(fpu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        if fpu2kernel4xi['COUNT2REFERENCE'] < 0:
            fpu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2kernel4fpu: " + " ** " + str(fpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
             
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            fpu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2kernel4fpu: " + " ** " + str(fpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; fpu2kernel4xi-yielded-by-release2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    fpu2kernel4xi ['ACK2RETURN']  = code2ack
    fpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2program4fpu = fpu2kernel4xi.keys()
    for key2program4fpu in keys2program4fpu:
        message2print = "{(Step 70/70) returning" + "; key2program4fpu-returning-by-release2kernel4fpu: " + str(key2program4fpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return fpu2kernel4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2kernel4fpu" usage = "
#
#   task4retain2kernel  = {} 
#   task4retain2kernel  ['COUNT2REFERENCE'] = 1 
#   response4retain2kernel = {}
#   
#   print('(Step 19A/700) OF FPU2KERNEL4XI5TEST - TRYING TO RETAIN PROGRAM OF FPU DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4retain2kernel = retain2kernel4fpu(task4retain2kernel)
#       print('(Step 19B/700) OF FPU2KERNEL4XI5TEST - RETAINED PROGRAM OF FPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 19Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO RETAIN PROGRAM OF FPU DEVICE ', time4xi())                                                                                                  
#
#">

# -------------------------------------------------------------------------------------------------   
def retain2kernel4fpu(task4retain2fpu=None):

    '''
    retains kernel of FPU
    '''
    global fpu2kernel4xi 
    global folder2lib4fpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2kernel4fpu"
    method2print = "retain2kernel4fpu"

    message2print = "{(Step 1A/33) started" + "; retain2kernel4fpu-started: " + str(retain2kernel4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2fpu-to-retain2kernel4fpu: " + str(task4retain2fpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/70) - PROVIDE TASKS, IF NECESSARY AND CHECK GIVEN TASKS 
    # -----------------------------------------------------------------------------------------    
    if task4retain2fpu is None:
        task4retain2fpu = {}
        task4retain2fpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 2A/33) set" + "; task4retain2fpu-set-by-retain2kernel4fpu to: " + str(task4retain2fpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    else:
        pass

    
    # -----------------------------------------------------------------------------------------
    # (Step 3/70) - CHECK COUNT2REFERENCE
    # -----------------------------------------------------------------------------------------         
    if 'COUNT2REFERENCE' in task4retain2fpu.keys():
        pass
    else:
        task4retain2fpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3A/33) set" + "; count2reference-set-by-retain2kernel4fpu to: " + str(task4retain2fpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                   
    if task4retain2fpu['COUNT2REFERENCE'] < 1:
        task4retain2fpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3B/33) set" + "; count2reference-set-by-retain2kernel4fpu to: " + str(task4retain2fpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
        
    # -----------------------------------------------------------------------------------------
    # (Step 4/70) - INITIALIZE PROGRAM IF NECESSARY
    # -----------------------------------------------------------------------------------------
    try:
        if fpu2kernel4xi is None:
            fpu2kernel4xi = create2kernel4fpu()
            message2print = "{(Step 4A/70) created" + "; fpu2kernel4xi-created-by-retain2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                                          
    except:
        try:
            fpu2kernel4xi = create2kernel4fpu()
            message2print = "{(Step 4B/70) created" + "; fpu2kernel4xi-created-by-retain2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
        except:
            fpu2kernel4xi = {}
            message2print = "{(Step 4Z/70) yielded" + "; fpu2kernel4xi-yielded-by-retain2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z-' 


    # -----------------------------------------------------------------------------------------
    # (Step 5/70) - RETAIN
    # -----------------------------------------------------------------------------------------             
    try:
        fpu2kernel4xi['COUNT2REFERENCE'] = fpu2kernel4xi['COUNT2REFERENCE'] + task4retain2fpu['COUNT2REFERENCE']
        message2print = "{(Step 6A/70) calculated" + "; count2reference-calculated-by-retain2kernel4fpu: " + str(fpu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1            
        if fpu2kernel4xi['COUNT2REFERENCE'] <= 0:
            fpu2kernel4xi['COUNT2REFERENCE'] = 1
            message2print = "{(Step 6Z1/70) warning" + "; count2reference-warning-by-retain2kernel4fpu: " + " ** " + str(fpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            code2nack  = code2nack + '6Z1-'
        else:
            code2ack  = code2ack + '6C-'

    except:
        try:
            fpu2kernel4xi['COUNT2REFERENCE'] = 1
        
            message2print = "{(Step 7Z1/70) warning" + "; count2reference-warning-by-retain2kernel4fpu: " + " ** " + str(fpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '7Z1-'
        
        except:
            message2print = "{(Step 7Z2/70) yielded" + "; fpu2kernel4xi-yielded-by-retain2kernel4fpu: " + str(fpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z2-'
        
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70) - RETURN           
    # -----------------------------------------------------------------------------------------
    
    fpu2kernel4xi ['ACK2RETURN']  = code2ack
    fpu2kernel4xi ['NACK2RETURN'] = code2nack     
     
    keys2program4fpu = fpu2kernel4xi.keys()
    for key2program4fpu in keys2program4fpu:
        message2print = "{(Step 70/70) returning" + "; key2program4fpu-returning-by-retain2kernel4fpu: " + str(key2program4fpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return fpu2kernel4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelinfo4fpu" usage = "
#
#   print('(Step 3B1/700) OF FPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFORMATION FOR FPU ', time4xi())     
#   try:
#       response4kernelinfo2fpu = get2kernelinfo4fpu() 
#       print('(Step 3B2/700) OF FPU2KERNEL4XI5TEST - GOT KERNEL INFORMATION FOR FPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF FPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFORMATION FOR FPU', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelinfo4fpu(task4getinfo2kernel=None):

    '''
    gets kernel information of FPU
    '''
    
    global fpu2kernel4xi
    global folder2lib4fpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelinfo4fpu"
    method2print = "get2kernelinfo4fpu"

    message2print = "{(Step 0A/33) started" + "; get2kernelinfo4fpu-started: " + str(get2kernelinfo4fpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelinfo4fpu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    fpu2kernel = {}
    try: 
        if fpu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR FPU           
            # -------------------------------------------------------------------------------------           
            fpu2kernel = create2kernel4fpu()
            message2print = "{(Step 1B2/33) initialized" + "; fpu2kernel-initialized-by-get2kernelinfo4fpu to: " + str(fpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; fpu2kernel4xi-using-by-get2kernelinfo4fpu: " + str(fpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF FPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            fpu2kernel = fpu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; fpu2kernel-got-by-get2kernelinfo4fpu: " + str(fpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF FPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4fpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                fpu2kernel [key2task] = fpu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-fpu2kernel-set-by-get2kernelinfo4fpu to: " + str(fpu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4fpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4fpu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; fpu2kernel4xi-using-by-get2kernel4fpu: " + str(fpu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            fpu2kernel = create2kernel4fpu()
            
            message2print = "{(Step 1F/33) initialized" + "; fpu2kernel-initialized-by-get2kernelinfo4fpu to: " + str(fpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                fpu2kernel = fpu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; fpu2kernel-set-by-get2kernelinfo4fpu to: " + str(fpu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4fpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        fpu2kernel [key2task] = fpu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-fpu2kernel -set-by-get2kernelinfo4fpu to: " + str(fpu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4fpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            fpu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; fpu2kernel-yielded-by-get2kernel4fpu: " + str(fpu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4fpu = fpu2kernel4xi.keys()
    for key2kernel4fpu in keys2kernel4fpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4fpu-returning-by-get2kernelinfo4fpu: " + str(key2kernel4fpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # CODE2ERROR ...
        
    return fpu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelarginfo4fpu" usage = "
#
#   print('(Step 3B1/700) OF FPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENTGS INFO FOR FPU ', time4xi())     
#   try:
#       response4kernelinfo2fpu = get2kernelarginfo4fpu(task4getinfo2kernel) 
#       print('(Step 3B2/700) OF FPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENTGS INFO FOR FPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF FPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENTGS INFO FOR FPU ', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelarginfo4fpu(task4getinfo2kernel=None):

    '''
    gets kernel argument information of FPU
    '''
    
    global fpu2kernel4xi
    global folder2lib4fpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelarginfo4fpu"
    method2print = "get2kernelarginfo4fpu"

    message2print = "{(Step 0A/33) started" + "; get2kernelarginfo4fpu-started: " + str(get2kernelarginfo4fpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelarginfo4fpu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    fpu2kernel = {}
    try: 
        if fpu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR FPU           
            # -------------------------------------------------------------------------------------           
            fpu2kernel = create2kernel4fpu()
            message2print = "{(Step 1B2/33) initialized" + "; fpu2kernel-initialized-by-get2kernelarginfo4fpu to: " + str(fpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; fpu2kernel4xi-using-by-get2kernelarginfo4fpu: " + str(fpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF FPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            fpu2kernel = fpu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; fpu2kernel-got-by-get2kernelarginfo4fpu: " + str(fpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF FPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4fpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                fpu2kernel [key2task] = fpu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-fpu2kernel-set-by-get2kernelarginfo4fpu to: " + str(fpu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4fpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4fpu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; fpu2kernel4xi-using-by-get2kernel4fpu: " + str(fpu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            fpu2kernel = create2kernel4fpu()
            
            message2print = "{(Step 1F/33) initialized" + "; fpu2kernel-initialized-by-get2kernelarginfo4fpu to: " + str(fpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                fpu2kernel = fpu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; fpu2kernel-set-by-get2kernelarginfo4fpu to: " + str(fpu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4fpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        fpu2kernel [key2task] = fpu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-fpu2kernel -set-by-get2kernelarginfo4fpu to: " + str(fpu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4fpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            fpu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; fpu2kernel-yielded-by-get2kernel4fpu: " + str(fpu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4fpu = fpu2kernel4xi.keys()
    for key2kernel4fpu in keys2kernel4fpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4fpu-returning-by-get2kernelarginfo4fpu: " + str(key2kernel4fpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return fpu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2buildinfo4fpu" usage = "
#
#   response4get2buildinfo = get2buildinfo4fpu()
#            
#">

# -------------------------------------------------------------------------------------------------   
def get2buildinfo4fpu(task4getinfo2build=None):

    '''
    gets fpu2build4xi and fpu2build4xi
    '''
    
    global fpu2build4xi
    global folder2lib4fpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2buildinfo4fpu"
    method2print = "get2buildinfo4fpu"

    message2print = "{(Step 0A/33) started" + "; get2buildinfo4fpu-started: " + str(get2buildinfo4fpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2build-passed-to-get2buildinfo4fpu: " + str(task4getinfo2build) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    fpu2build = {}
    try: 
        if fpu2build4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR FPU           
            # -------------------------------------------------------------------------------------           
            fpu2build = {}
            message2print = "{(Step 1B2/33) initialized" + "; fpu2build-initialized-by-get2buildinfo4fpu to: " + str(fpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; fpu2build4xi-using-by-get2buildinfo4fpu: " + str(fpu2build4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF FPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2build is None:
            task4getinfo2build = {}
            fpu2build = fpu2build4xi
            message2print = "{(Step 1C/33) using" + "; fpu2build-got-by-get2buildinfo4fpu: " + str(fpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4buildinfo = task4getinfo2build.keys()
        keys2task = task4getinfo2build.keys()
            
        # -------------------------------------------------------------------------------------
        # BUILD INFO OF FPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2build4fpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                fpu2build [key2task] = fpu2build4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-fpu2build-set-by-get2buildinfo4fpu to: " + str(fpu2build [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2build4fpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2build-using-by-get2build4fpu: " + str(task4getinfo2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; fpu2build4xi-using-by-get2build4fpu: " + str(fpu2build4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE BUILD           
            # -------------------------------------------------------------------------------------           
            fpu2build = {}
            message2print = "{(Step 1F/33) initialized" + "; fpu2build-initialized-by-get2buildinfo4fpu to: " + str(fpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2build is None:
                fpu2build = fpu2build4xi
                message2print = "{(Step 1G/33) set" + "; fpu2build-set-by-get2buildinfo4fpu to: " + str(fpu2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2build.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2build4fpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        fpu2build [key2task] = fpu2build4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-fpu2build -set-by-get2buildinfo4fpu to: " + str(fpu2build  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2build4fpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            fpu2build = {}
            message2print = "{(Step 1Z3/70) yielded" + "; fpu2build-yielded-by-get2build4fpu: " + str(fpu2build) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; fpu2build-returning-by-get2buildinfo4fpu: " + str(fpu2build) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
    
    return fpu2build
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelworkgroupinfo4fpu" usage = "
#     
#   print('(Step 2AB2/700) OF FPU2KERNEL4XI5TEST - TRYING TO GET KERNEL WORK GROUP INFORMATION ', time4xi())           
#   try:
#       response4link = get2kernelworkgroupinfo4fpu()
#       print('(Step 2BB2/700) OF FPU2KERNEL4XI5TEST - GOT KERNEL WORK GROUP INFORMATION ', time4xi()) 
#   except:
#       print('(Step 2Z2/700) OF FPU2KERNEL4XI5TEST *** FAILED TO KERNEL WORK GROUP INFORMATION ', time4xi())                                                                     
#          
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelworkgroupinfo4fpu(task4kernelworkgroupinfo2fpu=None):

    '''
    gets kernel workgroup info of FPU
    '''
    global fpu2kernel4xi                                                                                            # Kernel of FPU    
    global import2use4fpu                                                                                           # Imports of FPU
    global target2function4fpu                                                                                      # Target function of Process4Xi
    global folder2lib4fpu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelworkgroupinfo4fpu" 
    method2print = "get2kernelworkgroupinfo4fpu"

    message2print = "{(Step 1A/70) started" + "; get2kernelworkgroupinfo4fpu-started: " + str(get2kernelworkgroupinfo4fpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernelworkgroupinfo2fpu-to-get2kernelworkgroupinfo4fpu: " + str(task4kernelworkgroupinfo2fpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    process2kernelworkgroupinfo4fpu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernelworkgroupinfo2fpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernelworkgroupinfo2fpu-yielded-by-get2kernelworkgroupinfo4fpu: " + str(task4kernelworkgroupinfo2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - LINK SOURCES INSIDE PROGRAM OBJECT FOR FPU ! 
    # ---------------------------------------------------------------------------------------------    
    process2kernelworkgroupinfo4fpu = {}                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; process2kernelworkgroupinfo4fpu-initialized-by-get2kernelworkgroupinfo4fpu to: " + str(process2kernelworkgroupinfo4fpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}

    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                  
        # ---------------------------------------------------------------------------------------------             
        keys2code4fpu = fpu2kernel4xi['CODE4SOURCE'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2code4fpu-using-by-get2kernelworkgroupinfo4fpu: " + str(keys2code4fpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # dict_keys([folder2lib4fpu + 'fpu2sampler4xi5test.py'])
        
        unit4processing = "fpu"
        
        for key2code4fpu in keys2code4fpu:
            index2search=str.find(key2code4fpu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2link = key2code4fpu[index2search:]                                                          # fpu2sampler4xi5test.py
                index2search=str.find(target2link,".py")
                if index2search == -1:
                    pass
                else:
                    target2link4fpu = target2link[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2link4fpu-set-by-get2kernelworkgroupinfo4fpu to: " + str(target2link4fpu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # fpu2sampler4xi5test

                    p2code4fpu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4FPU 
                        # ---------------------------------------------------------------------------------------------    
      
                        try:
                            import2use4fpu.get(target2link4fpu, handle2error4fpu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2link4fpu-imported-by-get2kernelworkgroupinfo4fpu: " + str(target2link4fpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # fpu2sampler4xi5test
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4fpu-failed-by-get2kernelworkgroupinfo4fpu: " + str(import2use4fpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2link4fpu-used-by-get2kernelworkgroupinfo4fpu: " + str(target2link4fpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4FPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2fpu = Process4Xi(target=target2function4fpu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2fpu-created-by-get2kernelworkgroupinfo4fpu: " + str(p2fpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-2, initial)>
                        
                        process2kernelworkgroupinfo4fpu[key2code4fpu] = p2fpu
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2fpu.start()
                            message2print = "{(Step 34A/70) started" + "; p2fpu-started-by-get2kernelworkgroupinfo4fpu: " + str(p2fpu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-2
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4fpu = p2fpu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-get2kernelworkgroupinfo4fpu: " + str(status2process4fpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2fpu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2fpu-run-by-get2kernelworkgroupinfo4fpu: " + str(p2fpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-get2kernelworkgroupinfo4fpu: " + str(p2fpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-get2kernelworkgroupinfo4fpu: " + str(p2fpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-get2kernelworkgroupinfo4fpu: " + str(p2fpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2code4fpu-failed-by-get2kernelworkgroupinfo4fpu: " + str(p2code4fpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    

 
        message2print = "{(Step 38A/70) set" + "; process2kernelworkgroupinfo4fpu-set-by-get2kernelworkgroupinfo4fpu to: " + str(process2kernelworkgroupinfo4fpu)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; code-yielded-by-get2kernelworkgroupinfo4fpu: " + str(fpu2kernel4xi['CODE4SOURCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    fpu2kernel4xi ['ACK2RETURN']  = code2ack
    fpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; process2kernelworkgroupinfo4fpu-returning-by-get2kernelworkgroupinfo4fpu: " + str(process2kernelworkgroupinfo4fpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 
    return process2kernelworkgroupinfo4fpu
            
#</function4xi> 
 
                                        
# =================================================================================================
#<class4xi class = "FPU2Kernel4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for FPU kernels" usage = "Kernel4Xi of FPU"
#>

# =================================================================================================
class FPU2Kernel4Xi(object): 
    ''' 
    FPU2Kernel4Xi offers  methods for FPU kernels
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2fpu = cpu_corecount4xi()
    #"
    #/>
       
       
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'add2kernel',                      # ACK              

            'execute2kernel',                  # ACK 5.8    p169                                             
            'execute2task',                    # ACK 5.8    p172   
            'execute2nativekernel',            # ACK 5.8    p174     
            
            'create2kernel',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram',         # ACK 5.7.1  p158  
                       
            'delete2kernel',                   # ACK

            'fetch2kernel',                    # ACK 
            
            'get2kernelinfo',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo',         # ACK 5.7.3  p164  
            'get2kernelarginfo',               # ACK 5.7.3  p166                                  
            
            'release2kernel',                  # ACK 5.7.1  p159                                         
            'retain2kernel',                   # ACK 5.7.1  p159   
 
            'set2kernel',                      # ACK 
            'set2kernelcallback',              # ACK 
            'set2kernelarg',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel',                    # ACK 
            
            'sense',                           # ACK
            'reason',                          # ACK
            'ace')                             # ACK   
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-FPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 110A/700) OF FPU2KERNEL4XI5TEST - CREATING KERNEL OBJECT OF FPU ', time4xi())        
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                  
    #       # ---------------------------------------------------------------------------------------------        
    #       kernelobject2fpu = FPU2Kernel4Xi()
    #       print('(Step 110B/700) OF FPU2KERNEL4XI5TEST - CREATED KERNEL OBJECT OF FPU: ', kernelobject2fpu)                                  
    #       # 
    #   except:
    #       print('(Step 110Z/700) OF FPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL OBJECT OF FPU') 
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4kernel2fpu = None):
        '''
        _init__ method initializes FPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "FPU2Kernel4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-FPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        message2print = "{(Step 1B/33) borning" + "; fpu2kernel2xi-of-FPU2Kernel4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-fpu2kernel2xi-of-FPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2fpu-sharing-by-fpu2kernel2xi-of-FPU2Kernel4Xi: " + str(FPU2Kernel4Xi.classvariable2fpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4        
                                
        message2print = "{(Step 1E/33) passed" + "; task4kernel2fpu-passed-to-init-of-FPU2Kernel4Xi: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                      
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
    
        message2print = "{(Step 2A/33) passing" + "; task4kernel2fpu-passing-to-create2kernel4fpu-by-init-of-FPU2Kernel4Xi: " + str(task4kernel2fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
                
        fpu2kernel2xi = create2kernel4fpu(task4kernel2fpu)
        
        message2print = "{(Step 2B/33) performed" + "; create2kernel4fpu-performed-by-init-of-FPU2Kernel4Xi: " + str(create2kernel4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2kernel4fpu at 0x00000000041E54C8>
       
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; fpu2kernel2xi-of-FPU2Kernel4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-fpu2kernel2xi-of-FPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2fpu-shared-by-fpu2kernel2xi-of-FPU2Kernel4Xi: " + str(FPU2Kernel4Xi.classvariable2fpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #     
       
        message2print = "{(Step 3D/33) returning" + "; init-of-FPU2Kernel4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "add2kernel-of-FPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 132A/700) OF FPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL TO FPU  WITH METHOD', time4xi())         
    #   try:
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4fpu + 'fpu2dummy4xi.py'] = {}
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4fpu + 'fpu2dummy4xi.py'] [1] = '... profile = "11" />'
    #
    #       response4add2kernel = programobject2fpu.add2kernel(task4add2kernel) 
    #       print('(Step 132B/700) OF FPU2KERNEL4XI5TEST - ADDED KERNEL TO FPU  WITH METHOD', time4xi())
    #   except:
    #       print('(Step 132Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO ADD KERNEL TO FPU WITH METHOD *** ', time4xi())
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def add2kernel(self, task4add2kernel = None):
        '''
        adds kernel to FPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "add2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; add2kernel-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4add2kernel-passed-to-add2kernel-of-FPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4add2kernel-passing-to-add2kernel4fpu-by-add2kernel-of-FPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4add2kernel = add2kernel4fpu(task4add2kernel)

        message2print = "{(Step 2B/33) performed" + "; add2kernel4fpu-performed-by-add2kernel-of-FPU2Kernel4Xi: " + str(add2kernel4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4add2kernel-returning-by-add2kernel-of-FPU2Kernel4Xi: " + str(response4add2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4add2kernel
                                
                            
    #</methodize4xi>    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2task-of-FPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 240A/700) OF FPU2KERNEL4XI5TEST - TRYING TO EXECUTE TASK OF FPU WITH METHOD ', time4xi())    
    #   try:                               
    #       response4execute2task = programobject2fpu.execute2task() 
    #       print('(Step 240B/700) OF FPU2KERNEL4XI5TEST - EXECUTED TASK OF FPU WITH METHOD ', time4xi())
    #   except:
    #       print('(Step 240Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO EXECUTE TASK OF FPU WITH METHOD ', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2task(self, task4execute = None):
        '''
        executes task of kernel of FPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "execute2task"
                     
        message2print = "{(Step 1A/33) started" + "; execute2task-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute-passed-to-create-of-FPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute-passing-to-execute2task4fpu-by-execute2task-of-FPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        fpu2program2xi = execute2task4fpu(task4execute)

        message2print = "{(Step 2B/33) performed" + "; execute2task4fpu-performed-by-execute2task-of-FPU2Kernel4Xi: " + str(execute2task4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; fpu2program2xi-returning-by-execute2task-of-FPU2Kernel4Xi: " + str(fpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return fpu2program2xi
                     
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2nativekernel-of-FPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121A1/700) OF FPU2KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL OF FPU ', time4xi())      
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # COMPILE                        
    #       # ---------------------------------------------------------------------------------------------        
    #       response4compile = executeobject2fpu.execute2nativekernel()
    #       print('(Step 121A2/700) OF FPU2KERNEL4XI5TEST - EXECUTED KERNEL OF FPU', time4xi())                                   
    #   except:
    #       print('(Step 121AZ1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL OF FPU', time4xi())   
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2nativekernel(self, task4execute2kernel = None):
        '''
        executes native kernel of FPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "execute2nativekernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2nativekernel-of-FPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-create-of-FPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2nativekernel4fpu-by-execute2nativekernel-of-FPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        fpu2execute2xi = execute2nativekernel4fpu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2nativekernel4fpu-performed-by-execute2nativekernel-of-FPU2Kernel4Xi: " + str(execute2nativekernel4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; fpu2execute2xi-returning-by-execute2nativekernel-of-FPU2Kernel4Xi: " + str(fpu2execute2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return fpu2execute2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelworkgroupinfo-of-FPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121C1/700) OF FPU2KERNEL4XI5TEST - TRYING TO GET WORK GROUP INFOR OF FPU WITH METHOD ', time4xi())      
    #   try:
    #      
    #       response4getworkgroupinfo = programobject2fpu.get2kernelworkgroupinfo()
    #       print('(Step 121C2/700) OF FPU2KERNEL4XI5TEST - GOT WORK GROUP INFOR OF FPU WITH METHOD ', time4xi())                                   
    #   except:
    #       print('(Step 121CZ1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO GET WORK GROUP INFOR OF FPU WITH METHOD ', time4xi())  
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelworkgroupinfo(self, task4getworkgroupinfo = None):
        '''
        get kernel work group info OF FPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "get2kernelworkgroupinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelworkgroupinfo-of-FPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4getworkgroupinfo-passed-to-create-of-FPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4getworkgroupinfo-passing-to-get2kernelworkgroupinfo4fpu-by-get2kernelworkgroupinfo-of-FPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        fpu2program2xi = get2kernelworkgroupinfo4fpu(task4getworkgroupinfo)

        message2print = "{(Step 2B/33) performed" + "; get2kernelworkgroupinfo4fpu-performed-by-get2kernelworkgroupinfo-of-FPU2Kernel4Xi: " + str(get2kernelworkgroupinfo4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; fpu2program2xi-returning-by-get2kernelworkgroupinfo-of-FPU2Kernel4Xi: " + str(fpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return fpu2program2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernel-of-FPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 190A/700) OF FPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR FPU ', time4xi()) 
    #   try:
    #       kernelobject2fpu = FPU2Kernel4Xi()                            
    #       response4create2kernel = kernelobject2fpu.create2kernel()
    #       print('(Step 190B/700) OF FPU2KERNEL4XI5TEST - CREATED KERNEL FOR FPU ', time4xi())
    #   except:
    #       print('(Step 190Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR FPU ', time4xi())                                    
    #           
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernel(self, task4kernel2create = None):
        '''
        create2kernel method creates kernel objects of FPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "create2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernel-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-FPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernel4fpu-by-create2kernel-of-FPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #  
  
        fpu2kernel2xi = create2kernel4fpu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernel4fpu-performed-by-create2kernel-of-FPU2Kernel4Xi: " + str(create2kernel4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernel4fpu at 0x0000000003B0C5C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        keys2response4create = fpu2kernel2xi.keys() 
        message2print = "{(Step 33A/33) returning" + "; keys2response4create-returning-by-create2kernel-of-FPU2Kernel4Xi: " + str(keys2response4create) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # ['FUNCTION',
        #  'CODE2ERROR',
        #  'COUNT2REFERENCE',
        #  'DATA2CALLBACK',
        #  'BUFFER',
        #  'FUNCTION2CALLBACK',
        #  'ACK2RETURN',
        #  'QUEUE',
        #  'PLATFORM',
        #  'PROGRAM',
        #  'NACK2RETURN',
        #  'CONTEXT',
        #  'COMMANDQUEUE',
        #  'DEVICE',
        #  'EVENT',
        #  'PIPE']
        message2print = "{(Step 33B/33) returning" + "; function-returning-by-create2kernel-of-FPU2Kernel4Xi: " + str(fpu2kernel2xi['FUNCTION']) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # fpu2sampler4xi5test 
        
        return fpu2kernel2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernelsinprogram-of-FPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 130A/700) OF FPU2KERNEL4XI5TEST - CREATING KERNELS IN PROGRM FOR FPU ', time4xi())      
    #   try:
    #       response4create2kernelsinprogram = kernelobject2fpu.create2kernelsinprogram()
    #       print('(Step 130A/700) OF FPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRM FOR FPU ', time4xi())
    #   except:
    #       print('(Step 130Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO KERNELS IN PROGRM FOR FPU', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernelsinprogram(self, task4kernel2create = None):
        '''
        creates kernels in program of FPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "create2kernelsinprogram"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernelsinprogram-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-FPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernelsinprogram4fpu-by-create2kernelsinprogram-of-FPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        fpu2kernel2xi = create2kernelsinprogram4fpu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernelsinprogram4fpu-performed-by-create2kernelsinprogram-of-FPU2Kernel4Xi: " + str(create2kernelsinprogram4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernelsinprogram4fpu at 0x00000000040248C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; fpu2kernel2xi-returning-by-create2kernelsinprogram-of-FPU2Kernel4Xi: " + str(fpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return fpu2kernel2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delete2kernel-of-FPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 134A/700) OF FPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL IN PROGRAM OF FPU WITH METHOD ', time4xi())        
    #   try:
    #       task4delete2kernel = {}
    #       task4delete2kernel ['CODE4KERNEL'] = {}
    #       task4delete2kernel ['CODE4KERNEL'] [folder2lib4fpu + 'dummy3image4xi..py'] = 'Yes'
    #       task4delete2kernel ['SIZE4KERNEL'] = {}
    #       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4fpu + 'dummy3image4xi..py'] = 'Yes'
    #       
    #       response4delete2kernel = programobject2fpu.delete2kernel(task4delete2kernel)
    #       print('(Step 134B/700) OF FPU2KERNEL4XI5TEST - DELETED DELETE KERNEL IN PROGRAM of FPUWITH METHOD ', time4xi())                                                                  
    #   except:
    #       print('(Step 134Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO DELETE DELETE KERNEL IN PROGRAM OF FPU WITH METHOD *** ', time4xi())
    #                  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def delete2kernel(self, task4delete2kernel = None):
        '''
        deletes kernel in program of FPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "delete2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; delete2kernel-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4delete2kernel-passed-to-delete2kernel-of-FPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4delete2kernel-passing-to-delete2kernel4fpu-by-delete2kernel-of-FPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4delete2kernel = delete2kernel4fpu(task4delete2kernel)

        message2print = "{(Step 2B/33) performed" + "; delete2kernel4fpu-performed-by-delete2kernel-of-FPU2Kernel4Xi: " + str(delete2kernel4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4delete2kernel-returning-by-delete2kernel-of-FPU2Kernel4Xi: " + str(response4delete2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4delete2kernel
                                
                            
    #</methodize4xi>    


        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernel-of-FPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernel ...
    #   print('(Step 158A/700) OF FPU2KERNEL4XI5TEST - TRYING TO SET KERNEL OF FPU: ', time4xi()) 
    #   try: 
    #       response4set2kernel = kernelobject2fpu.set2kernel(task4set2kernel)
    #       print('(Step 158B/700) OF FPU2KERNEL4XI5TEST - SET KERNEL OF FPU: ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL OF FPU: ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernel(self, task4set2kernel = None):
        '''
        sets kernel FPU objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "set2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernel-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernel-passed-to-set2kernel-of-FPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernel-passing-to-set2kernel4fpu-by-set2kernel-of-FPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        fpu2kernel2xi = set2kernel4fpu(task4set2kernel)

        message2print = "{(Step 2B/33) performed" + "; set2kernel4fpu-performed-by-set2kernel-of-FPU2Kernel4Xi: " + str(set2kernel4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; fpu2kernel2xi-returning-by-set2kernel-of-FPU2Kernel4Xi: " + str(fpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return fpu2kernel2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelarg-of-FPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernelarg ...
    #   print('(Step 158A/700) OF FPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS FOR FPU: ', time4xi())
    #   try: 
    #       response4set2kernelarg = programobject2fpu.set2kernelarg(task4set2kernelarg)
    #       print('(Step 158B/700) OF FPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS FOR FPU ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS FOR FPU ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelarg(self, task4set2kernelarg = None):
        '''
        sets kernel arguments for FPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "set2kernelarg"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelarg-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelarg-passed-to-set2kernelarg-of-FPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelarg-passing-to-set2kernelarg4fpu-by-set2kernelarg-of-FPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        fpu2program2xi = set2kernelarg4fpu(task4set2kernelarg)

        message2print = "{(Step 2B/33) performed" + "; set2kernelarg4fpu-performed-by-set2kernelarg-of-FPU2Kernel4Xi: " + str(set2kernelarg4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; fpu2program2xi-returning-by-set2kernelarg-of-FPU2Kernel4Xi: " + str(fpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return fpu2program2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelinfo-of-FPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF FPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFO ', time4xi())    
    #   try:                               
    #       response4get2kernelinfo = kernelobject2fpu.get2kernelinfo()                                 
    #       print('(Step 106B/700) OF FPU2KERNEL4XI5TEST - GOT GET KERNEL INFO ', time4xi())                             
    #   except:
    #       print('(Step 106Z/700) OF FPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO ', time4xi()) 
    #   
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelinfo(self, task4getinfo2kernel=None):
        '''
        gets kernel info of FPU 
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "get2kernelinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelinfo-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        fpu2kernel2xi = get2kernelinfo4fpu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; fpu2kernel2xi-returning-by-get2kernelinfo-of-FPU2Kernel4Xi: " + str(fpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return fpu2kernel2xi
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelarginfo-of-FPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF FPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENT INFO OF FPU ', time4xi())    
    #   try:                               
    #       response4get2kernelarginfo = kernelobject2fpu.get2kernelarginfo()
    #       print('(Step 106B/700) OF FPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENT INFO OF FPU ', time4xi())                                   
    #   except:
    #       print('(Step 106Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENT INFO OF FPU ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelarginfo(self, task4getinfo2kernel=None):
        '''
        gets kernel argument info of FPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "get2kernelarginfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelarginfo-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:01:22 11/17/11 Pacific Standard Time

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        fpu2kernel2xi = get2kernelarginfo4fpu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; fpu2kernel2xi-returning-by-get2kernelarginfo-of-FPU2Kernel4Xi: " + str(fpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return fpu2kernel2xi
                            
    #</methodize4xi>
   
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2buildinfo-of-FPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A1/700) OF FPU2BUILD4XI5TEST - TRYING TO GET BUILD INFO ', time4xi())    
    #   try:                               
    #                               
    #       response4get2buildinfo = programobject2fpu.get2buildinfo()
    #       print('(Step 106A2/700) OF FPU2BUILD4XI5TEST - GOT BUILD INFO ', time4xi())    
    #   except:
    #       print('(Step 106Z1/700) OF FPU2BUILD4XI5TEST *** FAILED TO GET BUILD INFO ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2buildinfo(self, task4getinfo2build=None):
        '''
        get2buildinfo method gets objects of FPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "get2buildinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2buildinfo-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        fpu2build2xi = get2buildinfo4fpu(task4getinfo2build)
        
        message2print = "{(Step 2A/33) returning" + "; fpu2build2xi-returning-by-get2buildinfo-of-FPU2Kernel4Xi: " + str(fpu2build2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        return fpu2build2xi
                            
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2kernel-of-FPU2Kernel4Xi" usage = "
    #
    #   print('(Step 170A/700) OF FPU2KERNEL4XI5TEST - RELEASING KERNEL ', time4xi())  
    #   task4release2kernel  = {}
    #   task4release2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4release2kernel = kernelobject2fpu.release2kernel(task4release2kernel)
    #       print('(Step 170B/700) OF FPU2KERNEL4XI5TEST - RELEASED KERNEL ', time4xi())
    #   except:
    #       print('(Step 170Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL ', time4xi())                        
    #       keys2response = response4release2kernel.keys()
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2kernel(self, task4release2kernel = None):
        '''
        releases FPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "release2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; release2kernel-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2kernel-passed-to-release2kernel-of-FPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2kernel-passing-to-release2kernel4fpu-by-release2kernel-of-FPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        fpu2kernel2xi = release2kernel4fpu(task4release2kernel)

        message2print = "{(Step 2B/33) performed" + "; release2kernel4fpu-performed-by-release2kernel-of-FPU2Kernel4Xi: " + str(release2kernel4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; fpu2kernel2xi-returning-by-release2kernel-of-FPU2Kernel4Xi: " + str(fpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #               
                
        return fpu2kernel2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2kernel-of-FPU2Kernel4Xi" usage = "
    #
    #   print('(Step 180A/700) OF FPU2KERNEL4XI5TEST - RETAINING KERNEL ', time4xi())
    #   task4retain2kernel  = {}
    #   task4retain2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4retain2kernel = kernelobject2fpu.retain2kernel(task4retain2kernel)
    #       print('(Step 180B/700) OF FPU2KERNEL4XI5TEST - RETAINED KERNEL ', time4xi())
    #   except:
    #       print('(Step 180Z1/700) OF FPU2KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL ', time4xi())                    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2kernel(self, task4retain2kernel = None):
        '''
        retains FPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "retain2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; retain2kernel-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2kernel-of-FPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2kernel4fpu-by-retain-of-FPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
  
        fpu2kernel2xi = retain2kernel4fpu(task4retain2kernel)

        message2print = "{(Step 2B/33) performed" + "; retain2kernel4fpu-performed-by-retain2kernel-of-FPU2Kernel4Xi: " + str(retain2kernel4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; fpu2kernel2xi-returning-by-retain2kernel-of-FPU2Kernel4Xi: " + str(fpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
            
                
        return fpu2kernel2xi
                                                           
    #</methodize4xi>   
    
 
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2kernel-of-FPU2Kernel4Xi" usage = "
    #     
    #   print('(Step 210A/25) OF FPU2KERNEL4XI5TEST - TRYING TO TRACE FPU: ', time4xi())      
    #   trace2fpu = None
    #   try:
    #       trace2fpu = programobject2fpu.trace2kernel() 
    #               print('(Step 210B/25) OF FPU2KERNEL4XI5TEST - TRACE2FPU: ', trace2fpu)  
    #       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4fpu-failed {}; time: 04:40:24 11/16/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4fpu', 'METHOD': 'trace2kernel4fpu'}
    #        except:
    #           print('(Step 210Z1/25) OF FPU2KERNEL4XI5TEST *** FAILED TO TRACE FPU: ', trace2fpu) 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2kernel(self, task4trace2kernel = None):
        '''
        traces FPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "trace2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; trace2kernel-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2kernel-passed-to-trace-of-FPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2kernel-passing-to-trace2kernel4fpu-by-trace2kernel-of-FPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = trace2kernel4fpu(task4trace2kernel)

        message2print = "{(Step 2B/33) performed" + "; trace2kernel4fpu-performed-by-trace2kernel-of-FPU2Kernel4Xi: " + str(trace2kernel4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2kernel-of-FPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2kernel-of-FPU2Kernel4Xi" usage = "
    #        
    #   print('(Step 220A/25) OF FPU2KERNEL4XI5TEST - TRYING TO UNLOAD COMPILER OF FPU: ', time4xi())      
    #   try:
    #       response4execute2kernel = programobject2fpu.execute2kernel() 
    #       print('(Step 220B/25) OF FPU2KERNEL4XI5TEST - UNLOADED COMPILER OF FPU: ', response4execute2kernel)  
    #       # 
    #   except:
    #       print('(Step 220Z1/25) OF FPU2KERNEL4XI5TEST *** FAILED TO TO UNLOAD COMPILER OF FPU: ', time4xi()) 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def execute2kernel(self, task4execute2kernel = None):
        '''
        executes kernel
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "execute2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2kernel-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-trace-of-FPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2kernel4fpu-by-execute2kernel-of-FPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = execute2kernel4fpu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2kernel4fpu-performed-by-execute2kernel-of-FPU2Kernel4Xi: " + str(execute2kernel4fpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-execute2kernel-of-FPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelcallback-of-FPU2Kernel4Xi" usage = "
    #
    #   print('(Step 200A/700) OF FPU2KERNEL4XI5TEST - TRYING TO SET KERNELCALLBACK WITH METHOD OF OBJECT XI2FPU: ', programobject2fpu) 
    #   try:
    #       callback2fpu = programobject2fpu.set2kernelcallback()                                  
    #       print('(Step 200B/700) OF FPU2KERNEL4XI5TEST - SET KERNELWITH CALLBACK TO: ', callback2fpu)
    #       # 
    #   except:
    #       print('(Step 200Z/700) OF FPU2KERNEL4XI5TEST *** FAILED TO SET KERNELCALLBACK WITH METHOD ***', time4xi())
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelcallback(self, task4set2kernelcallback = None): 
        '''
        set2kernelcallback of FPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "FPU2Kernel4Xi"
        method2print = "set2kernelcallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelcallback-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelcallback-passed-to-set2kernelcallback-of-FPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelcallback-passing-to-set2kernelcallback-by-set2kernelcallback-of-FPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        
        callback2fpu4program = {} 
        try:
            callback2fpu4program = set2kernelcallback4fpu (task4set2kernelcallback)

            
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2fpu4program-failed-by-set2kernelcallback-of-FPU2Kernel4Xi: " + str(callback2fpu4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2fpu4program-returning-by-set2kernelcallback-of-FPU2Kernel4Xi: " + str(callback2fpu4program) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # <function trace2kernel4fpu at 0x00000000038CF5C8> 
        
                                             
        return callback2fpu4program
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-FPU2Kernel4Xi" usage = "
    #
    #   print('(Step 310A/700) OF FPU2KERNEL4XI5TEST - SENSING ', time4xi())  
    #   try:
    #       print(programobject2fpu.sense())
    #       print('(Step 310B/700) OF FPU2KERNEL4XI5TEST - SENSED ', time4xi()) 
    #       # 
    #   except:
    #       print('(Step 310Z/700) OF FPU2KERNEL4XI5TEST *** FAILED TO SENSE ', time4xi())     
    #
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses FPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'FPU2Kernel4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; FPU2Kernel4Xi-sensing-by-sense-of-FPU2Kernel4Xi: " + str(FPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
            
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-FPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2fpu-of-FPU2Kernel4Xi'] = FPU2Kernel4Xi.classvariable2fpu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-FPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; FPU2Kernel4Xi-sensed-by-sense-of-FPU2Kernel4Xi: " + str(FPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-FPU2Kernel4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-FPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 320A/700) OF FPU2KERNEL4XI5TEST - REASONING ', time4xi())
    #   try:
    #       print(programobject2fpu.reason())
    #       print('(Step 320B/700) OF FPU2KERNEL4XI5TEST - REASONED ', time4xi())
    #       # 
    #   except:
    #       print('(Step 320Z/700) OF FPU2KERNEL4XI5TEST *** FAILED TO REASON ', time4xi()) 
    #
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons FPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'FPU2Kernel4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; FPU2Kernel4Xi-reasoning-by-reason-of-FPU2Kernel4Xi: " + str(FPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-FPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
             
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-FPU2Kernel4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-FPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; FPU2Kernel4Xi-reasoned-by-reason-of-FPU2Kernel4Xi: " + str(FPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-FPU2Kernel4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #           
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-FPU2Kernel4Xi" usage = "
    #
    #   print('(Step 330A/700) OF FPU2KERNEL4XI5TEST - ACING ', time4xi())   
    #   try:
    #       print(programobject2fpu.ace())
    #       print('(Step 330B/700) OF FPU2KERNEL4XI5TEST - ACED ', time4xi())                                                 
    #       # 
    #   except:
    #       print('(Step 330Z/700) OF FPU2KERNEL4XI5TEST *** FAILED TO ACE ', time4xi())                                 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces FPU2Kernel4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'FPU2Kernel4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-FPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; FPU2Kernel4Xi-acing-by-ace-of-FPU2Kernel4Xi: " + str(FPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #      
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-FPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-FPU2Kernel4Xi'] = FPU2Kernel4Xi.classvariable2fpu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-FPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; FPU2Kernel4Xi-aced-by-ace-of-FPU2Kernel4Xi: " + str(FPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'fpu2codeprogram4xi.FPU2Kernel4Xi'> 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-FPU2Kernel4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
#</class4xi>

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   fpu2codeprogram4xi5test.txt
#   sense-fpu2codeprogram4xi5test.xml
#   reason-fpu2codeprogram4xi5test.xml
#   ace-fpu2codeprogram4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fpu2kernel4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
